diff --git a/typing/debug_core.ml b/typing/debug_core.ml
new file mode 100644
index 0000000..41d32cb
--- /dev/null
+++ b/typing/debug_core.ml
@@ -0,0 +1,2999 @@
+open Asttypes
+module Ast = Ast_helper
+
+open Types
+open Typedtree
+open Parsetree
+
+(* コンテキストの定義 *)
+type expr_context =
+  Empty
+| Lambda of pattern * expr_context
+| Let of rec_flag * value_binding list * expr_context
+type 'a context_t =
+  ('a * expr_context) * Env.t * (structure_item * Env.t) list
+
+(* ---------------------------------------------------------- *)
+
+(* ppf *)
+let ppf = Format.std_formatter
+
+let print_node_count =
+  false (* ノード数をカウントするときには true にする *)
+(* true にすると型デバッグはできなくなる *)
+
+let print_asked_expr =
+  false (* カウントされた質問を表示するときには true にする *)
+(* スライス表示用変数 (debug_slice.ml) *)
+
+let print_slice =
+  not print_node_count && (* ノード数カウント中はスライスを表示しない *)
+  false (* スライス結果を表示するときに true にする *)
+
+(* OCaml のエラーメッセージ Errors.report_error 制御用変数
+   (toplevel/toploop.ml, driver/compile.ml) *)
+
+let print_ocaml_error =
+  not print_node_count && (* ノード数カウント中は表示しない *)
+  true  (* OCaml のエラーメッセージを消すときに false にする *)
+
+(* スライスをするかどうかを制御する変数
+   (debug_slice.ml, debug_main.ml) *)     
+let on_exp_slice =
+  print_node_count || (* ノード数カウント中はスライスを行う *)
+  true (* スライスをしないときには false を代入する *)
+
+let on_pat_slice =
+  ref false (* パターンのスライスをしないときには false を代入する *)
+
+let on_file_output =
+  false (* 各種情報をログに出力する時には true にする *)
+
+(* ---------------------------------------------------------- *)
+(* デバッガ、スライサ共通の定義 *)
+open Ast
+
+module Attr = struct
+
+  (* ここから、ocamldoc/odoc_print.mli とほぼ同じ内容 *)
+  let (type_fmt, flush_type_fmt) =
+    let buf = Buffer.create 512 in
+    let fmt = Format.formatter_of_buffer buf in
+    let flush () =
+      Format.pp_print_flush fmt ();
+      let s = Buffer.contents buf in
+      Buffer.reset buf ;
+      s
+    in
+    (fmt, flush)
+  let string_of_type_expr t =
+    Printtyp.mark_loops t;
+    Printtyp.type_scheme_max ~b_reset_names: false type_fmt t;
+    flush_type_fmt ()
+  (* ここまで、ocamldoc/odoc_print.mli とほぼ同じ内容 *)
+
+  (* 式の attribute *)
+  (* of_expr : expression -> attribute *)
+  let of_expr ({pexp_loc = loc} as e) =
+    {attr_name = mkloc "exp" loc;
+     attr_payload = PStr [Str.eval ~loc e];
+     attr_loc = Location.none}
+
+  (* サイズの attribute *)
+  (* of_size : int -> attribute *)
+  let of_size n =
+    {attr_name = mknoloc "size";
+     attr_payload = PPat (Pat.constant (Const.int n), None);
+     attr_loc = Location.none}
+
+  (* 型の attribute *)
+  (* of_type : string -> Types.type_expr -> attribute *)
+  let of_type st te =
+    let open Lexing in
+    let lex = from_string (string_of_type_expr te) in
+    let open Parse in
+    {attr_name = mknoloc st;
+     attr_payload = PTyp (core_type lex);
+     attr_loc = Location.none}
+
+  let to_size {attr_name = {txt}; attr_payload = payload} = match payload with
+      PPat ({ppat_desc = Ppat_constant (Pconst_integer (n, None))}, None)
+         when txt = "size" -> int_of_string n
+    | _ -> failwith "Attr: mismatch"
+
+end
+
+(* ホール *)
+module Hole = struct
+  (* □の種類 *)
+  (* Exp : 式の□ *)
+  (* Pat : パターンの□ *)
+  (* Hole : 抽象化の必要がない *)
+  type t = Exp of attribute
+         | Pat of attribute
+         | Hole
+  (* □を求める関数 *)
+  (* Hole.hole' : ?exp:expression -> ?pat:pattern -> unit -> Hole.t *)
+  let rec hole' ?(exp = dummy_assertfalse ()) ?(pat = dummy_any ()) () =
+    match (exp, pat) with
+    | ({pexp_loc = loc; pexp_attributes = []}, _) when
+           exp <> dummy_assertfalse ~loc () && pat = dummy_any () ->
+       Exp ({attr_name = {txt = "exp"; loc};
+             attr_payload = PPat (pat, Some (exp));
+             attr_loc = Location.none}) (* 式の□ *)
+    | (_, {ppat_loc = loc; ppat_attributes = []}) when
+           exp = dummy_assertfalse () && pat <> dummy_any ~loc () ->
+       Pat ({attr_name = {txt = "pat"; loc};
+             attr_payload = PPat (pat, None);
+             attr_loc = Location.none}) (* パターンの□ *)
+    | _ -> Hole (* 既に抽象化されている *)
+
+  (* 式の抽象化 *)
+  (* Abst.expression : expression -> expression *)
+  and expression exp = match hole' ~exp () with
+    | Exp attr -> Exp.attr (dummy_assertfalse ~loc:exp.pexp_loc ()) attr
+    | _ -> exp
+
+  (* パターンの抽象化 *)
+  (* Abst.pattern : pattern -> pattern *)
+  and pattern pat = match hole' ~pat () with
+    | Pat attr -> Pat.attr (dummy_any ~loc:pat.ppat_loc ()) attr
+    | _ -> pat
+
+  (* ダミーの作成 *)
+  (* dummy_any : ~loc:loc -> unit -> pattern *)
+  (* その他 : ~loc:loc -> unit -> expression *)
+  and dummy_any ?(loc = Location.none) () =
+    Pat.any ~loc ()
+  and dummy_false ?(loc = Location.none) () =
+    Exp.construct ~loc (mknoloc (Longident.Lident "false")) None
+  (* and dummy_true ?(loc = Location.none) () =
+    Exp.construct ~loc (mknoloc (Longident.Lident "true")) None *)
+  and dummy_assertfalse ?(loc = Location.none) () =
+    Exp.assert_ ~loc (dummy_false ())
+  and dummy_int0 ?(loc = Location.none) () =
+    Exp.constant ~loc (Const.int 0)
+  and dummy_fun ?(loc = Location.none) () =
+    Exp.fun_ ~loc Nolabel None (dummy_any ()) (dummy_assertfalse ())
+
+  (* 変数として□を呼び出す用：lidになっている *)
+  let skeleton = mknoloc (Longident.Lident "□")
+                 (* was: (Longident.parse "□") *)
+
+  (* □ を定義する structure_item *)
+  let item =
+    (* let □ = assert false *)
+    let p = Pat.var (mknoloc "□") in
+    let e = dummy_assertfalse () in
+    let vs = [Vb.mk p e] in
+    Str.value Nonrecursive vs
+
+  let of_exp'' loc attrs =
+    Exp.ident ~loc ~attrs skeleton
+
+  let rec of_exp' attrs e = match attrs with
+    | [] ->
+       let attrs = (Attr.of_expr e) :: attrs in
+       of_exp'' e.pexp_loc attrs
+    | {attr_name = {txt; loc}; attr_payload; attr_loc} :: rest ->
+       if txt = "exp" then
+         e
+       else if txt = "dummy" then
+         of_exp'' e.pexp_loc ({attr_name = {txt = "exp"; loc};
+                               attr_payload; attr_loc} :: rest)
+       else
+         of_exp' rest e
+
+  let of_exp e =
+    of_exp' e.pexp_attributes e
+
+  let of_pat ({ppat_loc = loc; ppat_attributes = attrs} as p) =
+    if List.exists (fun {attr_name = {txt = name}} -> name = "pat") attrs then p
+    else
+      let attrs = {attr_name = mkloc "pat" loc;
+                   attr_payload = PPat (p, None);
+                   attr_loc = Location.none} :: attrs in
+      Pat.any ~loc ~attrs ()
+
+
+  (* スケルトンのチェック *)
+  let check_loc expr slice = expr.pexp_loc = slice.pexp_loc
+  let check_skeleton expr = check_loc (Exp.ident skeleton) expr
+
+  (* 式の抽象化 *)
+  (* to_exp : expression -> expression *)
+  let rec to_exp exp = match exp.pexp_attributes with
+      [] -> raise Not_found
+    | {attr_name = {txt = "exp"};
+       attr_payload = PStr [{pstr_desc = Pstr_eval (exp', _)}]} :: _ -> exp'
+    | _ :: rest -> to_exp {exp with pexp_attributes = rest}
+
+  (* 位置情報のない□ *)
+  let exp = Exp.ident skeleton
+
+end
+
+let rec get_type_name typ = match typ.desc with
+  | Tconstr (path, _, _) ->
+     (* 定義名とモジュール名のリストを返す *)
+     let lst =
+       (* was: (Longident.flatten (Longident.parse (Path.name path))) *)
+       match Path.flatten path with
+         `Ok (id, acc) -> Ident.name id :: acc
+       | _ -> failwith "error in get_type_name" in
+     List.fold_left (
+         fun (type_name, mod_names) s ->
+         (s, if type_name = "" then mod_names
+             else type_name :: mod_names)
+       ) ("", []) lst
+  | Tsubst (t) -> get_type_name t
+  | Tlink (t) -> get_type_name t
+  | _ -> assert false
+
+let rec get_type_decl (type_name, mod_names) prefix = match prefix with
+    [] -> failwith "this type was not find."
+  | ({pstr_desc = d}, _) :: rest ->
+     match d with
+     | Pstr_module ({pmb_name = {txt = Some (name)};
+                     pmb_expr = {pmod_desc =
+                                   Pmod_structure (mod_str)}}) ->
+        (* モジュールの定義 *)
+        (* name が mod_names にある場合は mod_str も再帰に含める *)
+        get_type_decl
+          (type_name, mod_names)
+          (if List.exists (
+                  fun mod_name -> mod_name = name) mod_names
+           then List.fold_left (
+                    fun rest' s -> (s, Env.empty) :: rest'
+                  ) rest mod_str else rest)
+     | Pstr_type (_, tds) ->
+        (* 型の定義 *)
+        (* 名前が一致した場合に type_declaration を返す *)
+        begin
+          try
+            let td =
+              List.find (fun {ptype_name = {txt = name}} ->
+                          name = type_name) tds in
+            if print_slice then
+              Format.fprintf ppf "@[  find type_declaration. @]@.";
+            td
+          with _ -> get_type_decl (type_name, mod_names) rest
+        end
+     | _ -> get_type_decl (type_name, mod_names) rest
+
+(* decode_labels : type_expr -> prefix -> label_declaration list *)
+let decode_labels typ prefix =
+  match get_type_decl (get_type_name typ) prefix with
+  | {ptype_kind = Ptype_record (lds)} -> lds
+  | _ -> failwith "This type is not record."
+
+(* 矢印の分離 *)
+(* split_arrow : type_expr -> (type_expr * type_expr) option *)
+let rec split_arrow typ = match typ.desc with
+    Tarrow (_, t1, t2, _) -> Some (t1, t2)
+  | Tlink (typ') -> split_arrow typ'
+  | _ -> None
+
+(* タプルの分離 *)
+(* decode_tuple : type_expr -> type_expr option *)
+let rec decode_tuple typ = match typ.desc with
+    Ttuple (typs) -> Some (typs)
+  | Tlink (typ') -> decode_tuple typ'
+  | _ -> None
+
+(* pattern_variables : pattern -> string list *)
+(* collect all the pattern variables in a pattern *)
+let rec pattern_variables pat = match pat.ppat_desc with
+    Ppat_any -> []
+  | Ppat_var ({txt = st}) -> [st]
+  | Ppat_alias (p, {txt = st}) -> st :: pattern_variables p
+  | Ppat_constant (_) -> []
+  | Ppat_interval (_, _) -> []
+  | Ppat_tuple (ps) -> List.flatten (List.map pattern_variables ps)
+  | Ppat_construct (_, None) -> []
+  | Ppat_construct (_, Some (p)) -> pattern_variables p
+  | Ppat_variant (_, None) -> []
+  | Ppat_variant (_, Some (p)) -> pattern_variables p
+  | Ppat_record (lps, _) ->
+      List.flatten (List.map (fun (_, p) -> pattern_variables p) lps)
+  | Ppat_array (ps) -> List.flatten (List.map pattern_variables ps)
+  | Ppat_or (p1, p2) -> pattern_variables p1 @ pattern_variables p2
+  | Ppat_constraint (p, _) -> pattern_variables p
+  | Ppat_type (_) -> []
+  | Ppat_lazy (p) -> pattern_variables p
+  | Ppat_unpack ({txt = Some (st)}) -> [st]
+  | Ppat_unpack ({txt = None}) -> []
+  | Ppat_exception (p) -> pattern_variables p
+  | Ppat_extension (_) -> []
+  | Ppat_open (_, p) -> pattern_variables p
+
+let rec plug_expr expr cxt = match cxt with
+  | Empty -> expr
+  | Lambda (pat, c) ->
+     (* パターン変数を全て集め *)
+     let vars = pattern_variables pat in
+     (* 変数名から変数の expression を作る *)
+     let varexp x = Exp.ident (mknoloc (Longident.Lident x)) in
+     (* expr と組にして body に入れる。これでパターン変数の型を知る *)
+     (* ダミーの 0 を入れるのは、tuple 長が 2 以上でないとエラーになるため *)
+     let body = Exp.tuple (expr :: Hole.dummy_int0 () :: List.map varexp vars) in
+     let exp = Exp.fun_ Nolabel None pat body in
+     plug_expr exp c
+  | Let (flg, bindings, c) ->
+     let exp = Exp.let_ flg bindings expr in
+     plug_expr exp c
+
+(* plug_str : (expression * expr_context) -> structure *)
+let plug_str (expr, cxt) = [Str.eval (plug_expr expr cxt)]
+
+(* collect_one : (string context_t * type_expr) context_t -> string list ->
+                 type_expr -> yes_no_list * type_expr *)
+let collect_one ((vartyps, cxt'), env, prefix) vars typ =
+  match decode_tuple typ with
+      Some (exp_typ :: _ :: typs) -> (* _ は dummy_int0 の型 *)
+        (List.map2 (fun v t -> (((v, cxt'), env, prefix), t)) vars typs
+         @ vartyps,
+         exp_typ)
+    | Some ([_]) | Some ([]) | None ->
+        Format.fprintf ppf "type:@.%a@." Printtyp.type_expr typ;
+        failwith "TypeDebugger: Error in collect_one"
+
+(* collect : expression context_t -> type_expr -> yes_no_list * type_expr *)
+let rec collect ((expr, cxt), env, prefix) t = match cxt with
+    Empty -> ([], t)
+  | Let (_, _, cxt') -> collect ((expr, cxt'), env, prefix) t
+  | Lambda (pat, cxt') ->
+      (* There and back again [Danvy&Goldberg ICFP'02] *)
+      let (vartyps, t') = collect ((expr, cxt'), env, prefix) t in
+      let vars = pattern_variables pat in
+      match split_arrow t' with
+          Some ((*t1*)_, t2) ->
+            collect_one ((vartyps, cxt'), env, prefix) vars t2
+        | None -> (* Can't happen *)
+            failwith "TypeDebugger: Error in collect"
+
+(* judge : expression context_t -> yes_no_list * type_expr *)
+let judge ((expr, cxt), env, prefix) =
+  let structure = plug_str (expr, cxt) in
+  let (structure', _, _, _) = Typemod.type_structure env structure in
+  match structure'.str_items with
+    {str_desc = Tstr_eval ({ exp_type = typ }, _)} :: [] ->
+      collect ((expr, cxt), env, prefix) typ
+  | _ -> failwith "TypeDebugger: Error in judge"
+
+(* map 関数の集合 *)
+module Map = struct
+
+  type 'a map2 = (pattern -> expression -> expression)
+                 -> (pattern -> expression -> pattern)
+                 -> 'a -> 'a
+  type 'a map1 = (expression -> expression) -> (pattern -> pattern)
+                 -> 'a -> 'a
+
+  let x1to2 x2 fe fp x = x2 (fun _ e -> fe e) (fun p _ -> fp p) x
+
+  (* 2引数 *)
+  let v2 fe2 fp2 ({pvb_pat = p; pvb_expr = e} as v) =
+    {v with pvb_pat = fp2 p e; pvb_expr = fe2 p e}
+  let c2 fe2 fp2 ({pc_lhs = p; pc_rhs = e} as c) =
+    {c with pc_lhs = fp2 p e; pc_rhs = fe2 p e}
+
+  (* 1引数 *)
+  let v1 fe fp v = x1to2 v2 fe fp v
+  let c1 fe fp c = x1to2 c2 fe fp c
+  let e1 fe _ e = fe e
+  let p1 _ fp p = fp p
+  let le fe _ (l, e) = (l, fe e)
+  let lp _ fp (l, p) = (l, fp p)
+  let id = fun x -> x
+
+  (* 差し替え *)
+  let set_exp x1 x e = x1 (fun _ -> e) id x
+  let set_pat x1 x p = x1 id (fun _ -> p) x
+
+  (* 式の抜き出し *)
+  let e_in_v v = v.pvb_expr
+  let e_in_c c = c.pc_rhs
+
+end
+
+
+let skeleton' = Ast.Exp.ident Hole.skeleton
+
+let hole_str = Hole.item
+let hole_of_exp exp = Hole.of_exp exp
+let hole_of_pat pat = Hole.of_pat pat
+
+module Desc = struct
+
+  (* desc 生成関数の型 *)
+  type 'a make_exp_desc =
+    'a list -> expression -> expression_desc
+  type make_exp_desc2 =
+    expression -> expression -> expression option -> expression_desc
+
+  type 'b make_pat_desc = 'b list -> pattern -> pattern_desc
+  
+  (* open Abst *)
+  let wildcard = Ast.Pat.any ()
+
+  (* pattern : pattern_desc -> pattern -> pattern *)
+  let pattern ppat_desc pat = {pat with ppat_desc}
+  
+  (* expression : expression_desc -> expression -> expression *)
+  let expression pexp_desc expr = {expr with pexp_desc}
+
+  (* to_pat :
+      ('a list -> pattern -> pattern_desc)
+     -> 'a list -> pattern -> pattern -> pattern *)
+  let to_pat fd ys p pat = pattern (fd ys p) pat
+
+  (* to_exp :
+      ('a list -> expression -> expression_desc)
+    -> 'a list -> expression -> expression -> expression *)
+  let to_exp fd xs e expr = expression (fd xs e) expr
+  let to_exp2 fd e1 e2 eop expr = expression (fd e1 e2 eop) expr
+
+  
+  (* ppat_desc の生成 *)
+  let p_alias str _ p = Ppat_alias (p, str)
+  let p_tuple ps _ = Ppat_tuple (ps)
+  let p_construct lid ps p =
+    if ps = [] then Ppat_construct (lid, Some p)
+    else if p = wildcard then Ppat_construct (lid, None)
+    else Ppat_construct (lid, Some (to_pat p_tuple ps p p))
+  let p_variant l _ p = Ppat_variant (l, Some p)
+  let p_record flg lps _ = Ppat_record (lps, flg)
+  let p_array ps _ = Ppat_array (ps)
+  let p_or p1 p2 = Ppat_or (p1, p2)
+  let p_constraint ct _ p = Ppat_constraint (p, ct)
+  
+  (* pexp_desc の生成 *)
+  let e_let flg vs e = Pexp_let (flg, vs, e)
+  let e_function cs _ = Pexp_function (cs) (*
+  let e_fun l eop p e = Pexp_fun (l, eop, p, e)
+  let e_apply les e = Pexp_apply (e, les) *)
+  let e_match cs e = Pexp_match (e, cs)
+  let e_try cs e = Pexp_try (e, cs)
+  let e_tuple es _ = Pexp_tuple (es)
+  let e_construct lid es e =
+    if es = [] then Pexp_construct (lid, Some e)
+    else if e = skeleton' then Pexp_construct (lid, None)
+    else Pexp_construct (lid, Some (to_exp e_tuple es e e))
+  (*  let e_variant l _ e = Pexp_variant (l, Some e) *)
+  (* let e_record les e =
+    if e = skeleton' then Pexp_record (les, None)
+    else Pexp_record (les, Some e)
+  let e_field lid _ e = Pexp_field (e, lid)
+  let e_setfield lid e1 e2 = Pexp_setfield (e1, lid, e2)
+  let e_array es _ = Pexp_array (es)
+  let e_constraint ct _ e = Pexp_constraint (e, ct)
+  let e_ifthenelse e1 e2 eop = Pexp_ifthenelse (e1, e2, eop)
+  let e_sequence e1 e2 = Pexp_sequence (e1, e2)
+  *)
+  (* こっちを使う *)
+  let enop e = if Hole.check_skeleton e then None else Some e
+  let deop eop = match eop with None -> skeleton' | Some e -> e
+
+  (* make_exp_desc *)
+  let pexp_let flg vs e = Pexp_let (flg, vs, e)
+  let pexp_function cs _ = Pexp_function (cs)
+  let pexp_fun l eop p _ e = Pexp_fun (l, eop, p, e)
+  let pexp_apply les e = Pexp_apply (e, les)
+  let pexp_match cs e = Pexp_match (e, cs)
+  let pexp_try cs e = Pexp_try (e, cs)
+  let pexp_tuple es _ = Pexp_tuple (es)
+  let pexp_construct lid _ e = Pexp_construct (lid, enop e)
+  let pexp_variant l _ e = Pexp_variant (l, enop e)
+  let pexp_record les e = Pexp_record (les, enop e)
+  let pexp_field lid _ e = Pexp_field (e, lid)
+  let pexp_array es _ = Pexp_array (es)
+  let pexp_constraint ct _ e = Pexp_constraint (e, ct)
+  let pexp_assert _ e = Pexp_assert (e)
+  (* make_exp_desc2 *)
+  let pexp_setfield lid e1 e2 _ = Pexp_setfield (e1, lid, e2)
+  let pexp_ifthenelse e1 e2 eop = Pexp_ifthenelse (e1, e2, eop)
+  let pexp_sequence e1 e2 _ = Pexp_sequence (e1, e2)
+
+  let flat f prefix env cxt x = f ((x, cxt), env, prefix)
+
+  module type Typ =
+    sig
+      type t
+      val internal : t -> t -> bool
+      val leaf : t -> bool
+      val comp : ?mode:bool -> t -> t -> int
+      val map : (t -> t) -> t -> t
+      val map_all : (t -> t) -> t -> t
+      val fold : ('a -> t -> 'a) -> 'a -> t -> 'a
+      val fold_all : ('a -> t -> 'a) -> 'a -> t -> 'a
+      val replace : t -> t -> t
+    end
+
+  let internal root node =
+    let open Location in
+    match (root, node) with
+      ({loc_start = root_s; loc_end = root_e},
+       {loc_start = node_s; loc_end = node_e}) ->
+        root_s <= node_s && node_e <= root_e
+
+  (* pattern *)
+  module Pat = struct
+    type t = pattern
+    let internal p0 p1 = internal p0.ppat_loc p1.ppat_loc
+
+    let node b {ppat_desc} = match ppat_desc with
+      | Ppat_any | Ppat_var _ | Ppat_constant _ -> b (* leaf : yes *)
+      | Ppat_construct (_, None) | Ppat_variant (_, None) -> b (* leaf : yes *)
+      | _ -> not b (* leaf : no *)
+
+    let leaf e = node true e
+
+    let comp ?(mode = false) p1 p2 =
+      (* true : 位置情報の比較 *)
+      (* 1 : e1 のほうが後 *)
+      (* 0 : 内包 *)
+      (* -1 : e2 のほうが後 *)
+      if mode then
+        let open Location in
+        if p2.ppat_loc.loc_end < p1.ppat_loc.loc_start then 1
+        else if p1.ppat_loc.loc_end < p2.ppat_loc.loc_start then -1
+        else 0
+      else
+        (* false : e1 と e2 の一致度 *)
+        (* 1 : 完全一致 *)
+        (* 0 : 部分一致 *)
+        (* -1 : 不一致 *)
+        if p1 = p2 then 1
+        else if p1.ppat_loc = p2.ppat_loc then 0
+        else -1
+
+    let check_loc patt slice = patt.ppat_loc = slice.ppat_loc
+    let check patt = check_loc wildcard patt
+
+    let enop p = if check p then None else Some p
+    let deop pop = match pop with None -> wildcard | Some p -> p
+
+    let map f patt =
+
+      let f1 map1 fd xs p =
+        {patt with
+          ppat_desc =
+            fd (List.map (map1 f Map.id) xs)
+               (if check p then p else f p)}
+
+      and f2 fd p1 p2 pop =
+        {patt with
+          ppat_desc =
+            fd (f p1) (f p2)
+               (if pop = None then None else enop (f (deop pop)))} in
+
+      if leaf patt then patt
+      else
+        match patt.ppat_desc with
+        | Ppat_alias (p, str) ->
+           f1 Map.p1 (p_alias str) [] p
+        | Ppat_tuple (ps) ->
+           f1 Map.p1 p_tuple ps wildcard
+        | Ppat_construct (lid, Some p) ->
+           f1 Map.p1 (p_construct lid) [] p
+        | Ppat_variant (l, Some p) ->
+           f1 Map.p1 (p_variant l) [] p
+        | Ppat_record (ls, flg) ->
+           f1 Map.lp (p_record flg) ls wildcard
+        | Ppat_array (ps) ->
+           f1 Map.p1 p_array ps wildcard
+        | Ppat_or (p1, p2) ->
+           f2 (fun p1 p2 _ -> p_or p1 p2) p1 p2 None
+        | Ppat_constraint (p, ct) ->
+           f1 Map.p1 (p_constraint ct) [] p
+        | _ -> failwith "not supported."
+
+    let rec map_all f patt =
+      if leaf patt then f patt
+      else f (map (map_all f) patt)
+
+    let fold f init patt =
+      let f0 p =
+        if check p then init else f init p in
+      let f1 p_in_x xs p = 
+        List.fold_left f (f0 p) (List.map p_in_x xs)
+      and f2 p1 p2 pop = f (f (f0 (deop pop)) p2) p1 in
+
+      match patt.ppat_desc with
+      | Ppat_alias (p, _) -> f0 p
+      | Ppat_tuple (ps) -> f1 Map.id ps wildcard
+      | Ppat_construct (_, Some p) -> f0 p
+      | Ppat_variant (_, Some p) -> f0 p
+      | Ppat_record (ls, _) -> f1 snd ls wildcard
+      | Ppat_array (ps) -> f1 Map.id ps wildcard
+      | Ppat_or (p1, p2) -> f2 p1 p2 None
+      | Ppat_constraint (p, _) -> f0 p
+      | _ -> init
+
+    let rec fold_all f init patt =
+      if leaf patt then f init patt
+      else f (fold (fold_all f) init patt) patt
+
+    let replace patt p =
+      if patt.ppat_loc = p.ppat_loc then patt else p
+
+    let find' name pat = match pat.ppat_desc with
+        Ppat_var {txt} -> txt = name
+      | Ppat_alias (_, {txt}) -> txt = name
+      | Ppat_unpack {txt = Some (txt)} -> txt = name
+      | _ -> false
+
+    let rec find name pat =
+      if find' name pat then pat
+      else if leaf pat then wildcard
+      else
+        fold (
+          fun pat' p ->
+            if pat' = wildcard then
+              find name p
+            else
+              pat'
+        ) wildcard pat
+
+    let complete ((pat, cxt), env, prefix) =
+      if print_slice then
+        Format.fprintf ppf "@[Pat.complete : %a@]@."
+             Pprintast.pattern pat;
+
+      match pat.ppat_desc with
+      | Ppat_record (lps, flg) ->
+          (* レコード *)
+          (* 足りないフィールドを補う *)
+          (* あるいは、型の情報を記録 *)
+          let (pat, lps') =
+            try
+(*
+type 'a context_t =
+  ('a * expr_context) * Env.t * (structure_item * Env.t) list
+*)
+              let dummy_record =
+                Exp.record
+                  (List.map (fun (l, _) -> (l, skeleton')) lps) (Some skeleton') in
+
+              if print_slice then
+                Format.fprintf ppf "@[dummy_record : %a@]@."
+                  Pprintast.expression dummy_record;
+
+              let (_, exp_typ) = judge ((dummy_record, cxt), env, prefix) in
+
+              if print_slice then
+                Format.fprintf ppf "@[  make dummy labels: type %a @]@."
+                  Printtyp.type_expr exp_typ;
+
+              let dummy_lps =
+                List.map (
+                  fun {pld_name = {txt = t; loc = l}} ->
+                    ({txt = Longident.Lident t; loc = l}, wildcard)
+                    (* asai: Lident was parse *)
+                ) (decode_labels exp_typ prefix) in
+
+
+              (Ast_helper.Pat.attr pat (Attr.of_type "type" exp_typ),
+              List.fold_left (
+                fun lst (ln, pn) ->
+                  List.map (
+                    fun (lm, pm) ->
+                      if Longident.last lm.txt = Longident.last ln.txt
+                      then (ln, pn) else (lm, pm)) lst
+              ) dummy_lps lps)
+            with
+              _ -> (pat, lps) in
+
+          pattern (p_record flg lps' wildcard) pat
+
+    | _ -> pat (* その他はそのまま *)
+  end
+
+  (* expression *)
+  module Exp = struct
+    type t = expression
+    let internal e0 e1 = internal e0.pexp_loc e1.pexp_loc
+
+    let node b {pexp_desc} = match pexp_desc with
+      | Pexp_ident _ | Pexp_constant _ -> b (* leaf : yes *)
+      | Pexp_construct (_, None) | Pexp_variant (_, None) -> b (* leaf : yes *)
+      | _ -> not b (* leaf : no *)
+
+    let leaf e = node true e
+
+    let comp ?(mode = false) e1 e2 =
+      if mode then
+        (* true : 位置情報の比較 *)
+        (* 1 : e1 のほうが後 *)
+        (* 0 : 内包 *)
+        (* -1 : e2 のほうが後 *)
+        let open Location in
+        if e2.pexp_loc.loc_end < e1.pexp_loc.loc_start then 1
+        else if e1.pexp_loc.loc_end < e2.pexp_loc.loc_start then -1
+        else 0
+      else
+        (* false : e1 と e2 の一致度 *)
+        (* 1 : 完全一致 *)
+        (* 0 : 部分一致 *)
+        (* -1 : 不一致 *)
+        if e1 = e2 then 1
+        else if e1.pexp_loc = e2.pexp_loc then 0
+        else -1
+
+    let map f expr =
+
+      let f1 map1 fd xs e =
+        {expr with
+          pexp_desc =
+            fd (List.map (map1 f Map.id) xs)
+               (if Hole.check_skeleton e then e else f e)}
+
+      and f2 fd e1 e2 eop =
+        {expr with
+          pexp_desc =
+            fd (f e1) (f e2)
+               (if eop = None then None else enop (f (deop eop)))} in
+
+      if leaf expr then expr
+      else
+        match expr.pexp_desc with
+        | Pexp_let (flg, vs, e) ->
+           f1 Map.v1 (pexp_let flg) vs e
+        | Pexp_function (cs) ->
+           f1 Map.c1 pexp_function cs skeleton'
+        | Pexp_fun (l, eop, p, e) ->
+           f1 Map.e1 (pexp_fun l eop p) [] e
+        | Pexp_apply (e, les) ->
+           f1 Map.le pexp_apply les e
+        | Pexp_match (e, cs) ->
+           f1 Map.c1 pexp_match cs e
+        | Pexp_try (e, cs) ->
+           f1 Map.c1 pexp_try cs e
+        | Pexp_tuple (es) ->
+            f1 Map.e1 pexp_tuple es skeleton'
+        | Pexp_construct (lid, Some e) ->
+           f1 Map.e1 (pexp_construct lid) [] e
+        | Pexp_variant (l, Some e) ->
+           f1 Map.e1 (pexp_variant l) [] e
+        | Pexp_record (ls, eop) ->
+           f1 Map.le pexp_record ls (deop eop)
+        | Pexp_field (e, lid) ->
+           f1 Map.e1 (pexp_field lid) [] e
+        | Pexp_setfield (e1, lid, e2) ->
+           f2 (pexp_setfield lid) e1 e2 None
+        | Pexp_array (es) ->
+           f1 Map.e1 pexp_array es skeleton'
+        | Pexp_ifthenelse (e1, e2, eop) ->
+           f2 pexp_ifthenelse e1 e2 eop
+        | Pexp_sequence (e1, e2) ->
+           f2 pexp_sequence e1 e2 None
+        | Pexp_constraint (e, ct) ->
+           f1 Map.e1 (pexp_constraint ct) [] e
+        | Pexp_assert (e) ->
+           f1 Map.e1 pexp_assert [] e
+        | Pexp_send _ -> failwith "#use"
+        | _ -> failwith "not supported."
+
+    let rec map_all f expr =
+      if leaf expr then f expr
+      else f (map (map_all f) expr)
+
+    let fold f init expr =
+      let f0 e =
+        if Hole.check_skeleton e then init else f init e in
+      let f1 e_in_x xs e = 
+        List.fold_left f (f0 e) (List.map e_in_x xs)
+      and f2 e1 e2 eop = f (f (f0 (deop eop)) e2) e1 in
+
+      match expr.pexp_desc with
+      | Pexp_let (_, vs, e) -> f1 Map.e_in_v vs e
+      | Pexp_function (cs) -> f1 Map.e_in_c cs skeleton'
+      | Pexp_fun (_, _, _, e) -> f0 e
+      | Pexp_apply (e, ls) -> f1 snd ls e
+      | Pexp_match (e, cs) -> f1 Map.e_in_c cs e
+      | Pexp_try (e, cs) -> f1 Map.e_in_c cs e
+      | Pexp_tuple (es) -> f1 Map.id es skeleton'
+      | Pexp_construct (_, Some e) -> f0 e
+      | Pexp_variant (_, Some e) -> f0 e
+      | Pexp_record (ls, eop) ->
+         f1 snd ls (deop eop)
+      | Pexp_field (e, _) -> f0 e
+      | Pexp_setfield (e1, _, e2) -> f2 e1 e2 None
+      | Pexp_array (es) -> f1 Map.id es skeleton'
+      | Pexp_ifthenelse (e1, e2, eop) -> f2 e1 e2 eop
+      | Pexp_sequence (e1, e2) -> f2 e1 e2 None
+      | Pexp_constraint (e, _) -> f0 e
+      | Pexp_assert (e) -> f0 e
+      | _ -> init
+
+    let rec fold_all f init expr =
+      if leaf expr then f init expr
+      else f (fold (fold_all f) init expr) expr
+
+    let replace e expr =
+      if e.pexp_loc = expr.pexp_loc then e else expr
+
+    let restore les expr = match expr.pexp_desc with
+      | Pexp_tuple _ ->
+          {expr with pexp_desc = Pexp_tuple (List.map snd les)}
+      | Pexp_array _ ->
+          {expr with pexp_desc = Pexp_array (List.map snd les)}
+      | Pexp_construct (lid, Some e) ->
+          let e' = match les with
+              (_, e_) :: [] -> e_
+            | _ ->
+                {e with pexp_desc = Pexp_tuple (List.map snd les)} in
+          {expr with pexp_desc = Pexp_construct (lid, Some e')}
+      | Pexp_ifthenelse _ ->
+          let (e_if, e_then, e_else) = match les with
+            | (_, e_if') :: (_, e_then') :: (_, e_else') :: [] ->
+                (e_if', e_then', Some e_else')
+            | (_, e_if') :: (_, e_then') :: [] ->
+                (e_if', e_then', None)
+            | _ -> raise Not_found in
+          {expr with pexp_desc = Pexp_ifthenelse (e_if, e_then, e_else)}
+      | _ -> raise Not_found
+
+    let rec value_bindings ((vs, cxt), env, prefix) = match vs with
+      | [] -> []
+      | vn :: rest ->
+          (* let v1 fe fp v *)
+          let vn' =
+            Map.v1 Map.id
+              (flat Pat.complete prefix env cxt) vn in
+          let vn' =
+            try
+              let (_, tp) = judge ((
+                  Ast_helper.Exp.let_ Nonrecursive
+                    [{vn' with pvb_pat = Ast_helper.Pat.var (mknoloc "◆")}]
+                    (Ast_helper.Exp.ident
+                       {txt = (Longident.Lident "◆"); loc = Location.none}
+                       ), cxt), env, prefix) in
+              if print_slice then
+                Format.fprintf ppf "@[Vb.complete : %a@]@."
+                  Printtyp.type_expr tp;
+              {vn' with pvb_pat = {vn'.pvb_pat with ppat_attributes = [Attr.of_type "vb" tp]}}
+            with
+              _ -> vn' in
+
+          (* vn のみで定義した関数がエラーになるかどうかをチェック *)
+          let rest' = value_bindings ((rest, cxt), env, prefix) in
+          try
+            ignore (
+              Typemod.type_structure
+                env [Ast_helper.Str.value Recursive [vn']]);
+            (* エラーにならない *)
+            vn' :: rest'
+          with
+          | _ ->
+              (* エラーになる *)
+              rest' @ [vn']
+
+    let cases ((cs, cxt), env, prefix) =
+
+      (* case の pattern に型を与える *)
+      List.map (
+        Map.c1 Map.id
+          (flat Pat.complete prefix env cxt)
+      ) cs
+
+    let complete ((expr, cxt), env, prefix) =
+      if print_slice then
+        Format.fprintf ppf "@[Exp.complete : %a@]@."
+             Pprintast.expression expr;
+      let flat' f x =
+        f ((x, cxt), env, prefix) in
+      let pat' p =
+        flat' Pat.complete p in
+      let set fd fx ?(e = Hole.exp) xs =
+        to_exp fd (fx xs) e expr in
+
+      match expr.pexp_desc with
+      | Pexp_fun (l, eop, p, e) ->
+          let desc = pexp_fun l eop (pat' p) [] e in
+          expression desc expr
+
+      | Pexp_let (flg, vs, e) ->
+          (* let文 *)
+          set (e_let flg) (flat' (value_bindings)) ~e vs
+
+      | Pexp_function cs ->
+          (* function | P1 -> E1 | ... *)
+          (* csに含まれるパターン全てに対して同じように処理する *)
+          set e_function (flat' cases) cs
+
+      | Pexp_match (e, cs) ->
+          (* match E0 with P1 -> E1 | ... *)
+          (* csに含まれるパターン全てに対して同じように処理する *)
+          set e_match (flat' cases) ~e cs
+
+      | Pexp_try (e, cs) ->
+          (* try E0 with P1 -> E1 | ... *)
+          (* csに含まれるパターン全てに対して同じように処理する *)
+          set e_try (flat' cases) ~e cs
+
+      | Pexp_construct (lid, Some (e)) ->
+          set (e_construct lid) Map.id ~e []
+
+      | _ -> expr
+
+    let origin e = match List.find (
+        fun {attr_name = {txt}} -> txt = "dummy"
+      ) e.pexp_attributes with
+    | {attr_payload = PStr ({pstr_desc = Pstr_eval (slice, _)} :: _)} -> slice
+    | _ -> raise Not_found
+
+    let rec clear expr = match expr.pexp_desc with
+      | Pexp_apply (e, les) ->
+          let expr' =
+            try
+              restore les (origin e)
+            with _ -> expr in
+          clear' expr'
+      | _ -> clear' expr
+
+    and clear' expr = {(map clear expr) with pexp_attributes = []}
+
+  end
+
+  module Str = struct
+    let clear' item = match item.pstr_desc with
+      | Pstr_eval (slice, attr) ->
+          {item with
+           pstr_desc =
+             Pstr_eval
+               (Exp.clear slice, attr)}
+      | Pstr_value (flg, vs) ->
+          {item with
+           pstr_desc =
+             Pstr_value
+               (flg, List.map (
+                   fun v ->
+                     {v with
+                      pvb_expr = Exp.clear v.pvb_expr}) vs)}
+      | _ -> item
+    let clear structure = List.map clear' structure
+
+    let output name structure =
+      let file = open_out name in
+      output_string file
+        (Pprintast.string_of_structure structure);
+      close_out file
+
+  end
+
+  module Vb = struct
+    let complete = Exp.value_bindings
+  end
+(*
+  let restore = Exp.restore
+  let origin = Exp.origin
+*)
+end
+
+module Size = struct
+
+  module type Typ =
+    sig
+      type t
+      val get : t -> int
+      val set : t -> t
+      val reset : int -> t -> t
+      val comp : ?e':t -> t -> int
+    end
+
+  module Exp = struct
+    type t = expression
+
+    let get' n {pexp_attributes = attrs} =
+      List.fold_left (
+          fun n attr ->
+          try
+            let m = Attr.to_size attr in
+            m + n
+          with
+            _ -> n
+        ) n attrs
+
+    (* get : expression -> int *)
+    (* expr の size を取得 *)
+    let get expr = get' 0 expr
+
+    let set' ?(sel = false) n ({pexp_attributes = attrs} as expr) =
+      let attrs' =
+        List.map (
+            fun attr ->
+            try
+              let m = Attr.to_size attr in
+              Attr.of_size (abs m |> if sel then (-) n else (+) n)
+            with
+              _ -> attr
+          ) attrs in
+      if attrs = attrs' then
+        Ast.Exp.attr expr (Attr.of_size n)
+      else
+        {expr with pexp_attributes = attrs'}
+
+    (* Size.Exp.set と f を同時に処理する *)
+    let rec set_and f expr =
+      if Desc.Exp.leaf expr then
+        set' 1 expr
+      else
+        let expr' = Desc.Exp.map (set_and f) (f expr) in
+        let n = Desc.Exp.fold get' 1 expr' in
+        set' n expr'
+
+    let rec set expr =
+      if Desc.Exp.leaf expr then
+        set' 1 expr
+      else
+        let expr' = Desc.Exp.map set expr in
+        let n = Desc.Exp.fold get' 1 expr' in
+        set' n expr'
+
+    let reset n expr =
+      {expr with
+        pexp_attributes =
+          List.map (
+              fun attr ->
+              try
+                let _ = Attr.to_size attr in
+                Attr.of_size n
+              with
+                _ -> attr
+            ) expr.pexp_attributes}
+
+    let comp ?(e' = skeleton') e =
+      let n' = if e' = skeleton' then 1 else get e' and n = get e in
+      compare n' n
+
+  end
+
+
+  (*  let set_size = true *)
+  let set_resize = true
+
+  (* size を求める関数 *)
+  let get' n (*_, payload*) attr =
+    try
+      let m = Attr.to_size attr in
+      m + n
+    with
+      _ -> n
+
+  (* get int ->  expression -> int *)
+  let get n {pexp_attributes = attrs} =
+    List.fold_left get' n attrs
+
+
+  (* 比較関数 *)
+  (* comp1 : e の size と 1 を比較 *)
+  let comp1 e = compare (get 0 e) 1
+(*
+  (* is1 : sizeが1でtrue *)
+  let is1 e = comp1 e = 0
+
+  (* fltr1 : size が2以上 *)
+  let fltr1 e = 1 = comp1 e
+*)
+  (* fltr0 : sizeが1以上でtrue *)
+  let fltr0 e = 0 <= comp1 e
+
+  (* comp2 : e1 と e2 の、m までの距離を比較 *)
+  let comp2 m e1 e2 =
+    if comp1 e1 < 0 then 1
+    else if comp1 e2 < 0 then -1
+    else
+      let get_dist e = abs (m - get 0 e) in
+      compare (get_dist e1) (get_dist e2)
+
+  let get_one e = get 0 e
+(*
+  (* ある式のサイズをセットする *)
+  let set' ?(sel = false) n ({pexp_attributes = attrs} as expr) =
+    let attrs' =
+      List.map (
+          fun attr ->
+          try
+            let m = Attr.to_size attr in
+            Attr.of_size (abs m |> if sel then (-) n else (+) n)
+          with
+            _ -> attr
+        ) attrs in
+    if attrs = attrs' then
+      (* 追加 *)
+      (* 【旧バージョン】 *)
+      (* Exp.attr expr (mknoloc "size", Size n) *)
+      (* 【新バージョン】 *)
+      Ast.Exp.attr expr (Attr.of_size n)
+    else
+      (* 上書き *)
+      {expr with pexp_attributes = attrs'}
+
+  (* size を set する *)
+  let rec set expr =
+    if Desc.Exp.leaf expr then
+      (* 子ノードなし *)
+      set' 1 expr
+    else
+      (* 子ノードあり *)
+      let expr' = Desc.Exp.map set expr in
+      let n = Desc.Exp.fold get 1 expr' in
+      set' n expr'
+      *)
+  (* reset' : expr の size を n にする *)
+  let reset' n expr =
+    {expr with
+      pexp_attributes =
+        List.map (
+            fun attr ->
+            try
+              let _ = Attr.to_size attr in
+              Attr.of_size n
+            with
+              _ -> attr
+          ) expr.pexp_attributes}
+
+  let reset expr = reset' 0 expr
+      (*
+  let reset1 x expr =
+    reset' (get (x 0 1) expr) expr
+
+  let rec resize expr =
+
+    if Desc.Exp.leaf expr then expr
+
+    else
+      (* 未確定の子ノード *)
+      let children =
+        Desc.Exp.fold
+          (fun es e -> if fltr0 e then e :: es else es) [] expr in
+      match children with
+        [] -> reset expr
+      | first :: rest ->
+         let map f = Desc.Exp.map f expr in
+         let (n, expr') =
+           if rest = [] then
+             let e' = resize first in
+             (get_one e', map (fun e -> if first = e then e' else e))
+           else
+             let expr'' =
+               map (fun e -> if List.mem e children then resize e else e) in
+             (Desc.Exp.fold get 1 expr'', expr'') in
+         reset' n expr'
+
+  (* 確定させる *)
+  let terminated expr = set' ~sel:true 0 expr
+
+  (* terminated check *)
+  (* すべての式が terminated であれば true *)
+  let check' init expr = init && not (fltr0 expr)
+  let check expr = Desc.Exp.fold_all check' true expr
+*)
+  (* 子ノード *)
+  let children expr =
+    (* expr の半分に近いノードから昇順にソート *)
+    let children' =
+      Desc.Exp.fold (
+          fun acc exp ->
+          acc @ if fltr0 exp then [exp] else []) [] expr in
+    let comp' = comp2 ((get 2 expr) / 2) in
+
+    (* ソート *)
+    List.sort comp' children'
+
+  (*  let term_hole e = terminated (hole_of_exp e) *)
+  let reset_hole e = reset (hole_of_exp e)
+
+(*
+  let get_childNoResize expr =
+
+    (* 式exprのサイズ *)
+    let n = get_one expr in
+
+    if n = 1 then
+      (expr, Map.id, term_hole)
+
+    else
+
+    (* 比較関数 *)
+    let comp_child exp' exp =
+      if fltr0 exp && comp2 (n / 2) exp' exp >= 0 then exp else exp' in
+
+    let expr_cxt_one e' =
+      Desc.Exp.map_all (
+          fun e ->
+          if e = e' then term_hole e
+          else if Hole.check_loc e e' then e'
+          else e
+        ) expr in
+
+
+    let rec get_childNoResize' expr_cxt_expect expr' =
+      let child = Desc.Exp.fold comp_child expr' expr' in
+      if child = expr' then
+        (expr', expr_cxt_expect, expr_cxt_one)
+      else
+        let expr_cxt_expect' e' =
+          expr_cxt_expect (
+              Desc.Exp.map (
+                  fun e ->
+                  if Hole.check_loc e e'
+                  then e'
+                  else if fltr0 e then term_hole e
+                  else e) expr') in
+        get_childNoResize' expr_cxt_expect' child in
+
+    get_childNoResize' Map.id expr
+
+  let reset_hole e = reset (hole_of_exp e)
+
+  let get_childWithResize expr =
+
+    let n = get_one expr in
+
+    if Desc.Exp.leaf expr then
+      (* 子ノードなし *)
+      (expr, reset_hole, reset_hole)
+
+    else
+      let comp_child exp' exp =
+        if 0 <= comp2 (n / 2) exp' exp && fltr0 exp then exp else exp' in
+      let rec get_childWithResize' expr_cxt_expect expr' =
+        let child = Desc.Exp.fold comp_child expr' expr' in
+        if child = expr' then
+          let expr_cxt_one e' =
+            let slice =
+              Desc.Exp.map_all (
+                  fun e ->
+                  if e = e' then reset_hole e
+                  else if Hole.check_loc e e' then e' else e
+                ) expr in
+            resize slice in
+          (expr', expr_cxt_one, expr_cxt_expect)
+        else
+          let expr_cxt_expect' e' =
+            let n = get_one e' in
+            let slice = match expr'.pexp_desc with
+              | Pexp_apply (e, les) when Hole.check_loc e e' && n = 1 ->
+                 let les' =
+                   List.map (
+                       fun (ln, en) ->
+                       (ln, if fltr0 en then reset_hole e else e)
+                     ) les in
+                 {expr' with pexp_desc = Pexp_apply (e', les')} |> reset
+              | _ ->
+                 Desc.Exp.map (
+                     fun e ->
+                      if Hole.check_loc e e' then e'
+                      else if fltr0 e then reset_hole e
+                      else e
+                   ) expr' |> reset' n in
+            expr_cxt_expect slice in
+
+          get_childWithResize' expr_cxt_expect' child in
+
+      get_childWithResize' Map.id expr
+
+  let expect expr' e' =
+    Desc.Exp.map (
+        fun e ->
+        if Hole.check_loc e e' then e'
+        else if fltr0 e then reset_hole e
+        else e) expr'
+
+  let getChild _ getChild' expr_cxt_expect expr =
+
+    if Desc.Exp.leaf expr then
+      (expr, reset, reset_hole)
+
+    else
+      (* 探索とresize を同時に行う *)
+      let expr_cxt_one e =
+        let open Location in
+        let rec expr_cxt_one' e' =
+          (* 式のサイズ *)
+          let n = ref 1 in
+          let expr' =
+            Desc.Exp.map (
+                fun e'' ->
+                if e = e'' then reset_hole e''
+                else
+                  let expr'' =
+                    if e.pexp_loc = e''.pexp_loc then e
+                    else if
+                      e.pexp_loc.loc_end < e''.pexp_loc.loc_start
+                      || e''.pexp_loc.loc_end < e.pexp_loc.loc_start then e''
+                    else
+                      expr_cxt_one' e'' in
+                  n := get !n expr''; expr''
+              ) e' in
+          if !n = 1 then n := 0;
+          reset' !n expr' in
+        expr_cxt_one' expr in
+
+      getChild' expr_cxt_expect expr_cxt_one expr
+*)
+  let rec getChildSet' fltr3 fltr2 fltr' (expr', abst') =
+
+    let return () =
+      (expr', fun sel expr_cxt e -> expr_cxt (abst' sel e)) in
+
+    if fltr' expr' then
+      return ()
+    else
+      let comp e' e =
+        if fltr3 expr' e' e then
+          if fltr0 e then e else e'
+        else
+          if fltr2 e' e then e else e' in
+      let child = Desc.Exp.fold comp expr' expr' in
+      if child = expr' then
+        return ()
+      else
+        match expr'.pexp_desc with
+
+        | Pexp_construct (lid, Some ({pexp_desc = Pexp_tuple es} as en)) ->
+           let child'' = List.fold_left comp skeleton' es in
+           if child'' = skeleton' then
+             return ()
+           else
+             let abst sel e =
+               let m = ref 1 in
+               let set' e' = m := get !m e'; e' in
+
+               let expr'' =
+                 let sr sel' e' = if sel' then set' e' else reset_hole e' in
+                 let en' =
+                   Desc.Exp.map (
+                       fun e' ->
+                       match Desc.Exp.comp e e' with
+                       | 0 -> set' e
+                       | 1 -> sr sel e'
+                       | _ ->
+                          if Desc.Exp.comp ~mode:true e e' = 0 then set' e'
+                          else sr (not sel) e'
+                     ) en in
+
+                 if !m = 1 then m := 0;
+                 {expr' with
+                   pexp_desc =
+                     Pexp_construct (lid, Some (reset' !m en'))} in
+               if 0 < !m then m := !m + 1;
+               abst' sel (reset' !m expr'') in
+             getChildSet' fltr3 fltr2 fltr' (child'', abst)
+ 
+        | _ ->
+           (* construct の場合分けを追加する *)
+           let abst sel e =
+             let m = ref 1 in
+             let set' e' = m := get !m e'; e' in
+             let sr sel' e' = if sel' then set' e' else reset_hole e' in
+             let expr'' =
+               Desc.Exp.map (
+                   fun e' ->
+                   match Desc.Exp.comp e e' with
+                   | 1 -> sr sel e'
+                   | 0 -> set' e
+                   | _ ->
+                      if Desc.Exp.comp ~mode:true e e' = 0 then set' e'
+                      else sr (not sel) e'
+                 ) expr' in
+             if !m = 1 then m := 0;
+             abst' sel (reset' !m expr'') in
+           getChildSet' fltr3 fltr2 fltr' (child, abst)
+
+  let getChildSet expr =
+
+    let n = get_one expr / 2 in
+    let fltr3 expr' e' _ = expr' = e'
+    and fltr2 e' e = get_one e' < get_one e
+    and fltr' expr' = get_one expr' < n in
+    getChildSet' fltr3 fltr2 fltr' (expr, fun _ e -> e)
+
+  let getChildSet2 expr =
+    let n = get_one expr / 2 in
+    let fltr3 _ e' e = 0 <= comp2 n e' e
+    and fltr2 _ _ = false
+    and fltr' _ = false in
+    getChildSet' fltr3 fltr2 fltr' (expr, fun _ e -> e)
+(*
+  (* resize あり *)
+  let getChild2 expr =
+
+    let n = get_one expr in
+    let comp_child exp' exp =
+      if 0 <= comp2 (n / 2) exp' exp && fltr0 exp then exp else exp' in
+
+    let rec getChild' expr_cxt_expect expr_cxt_one expr' =
+      
+      let child = Desc.Exp.fold comp_child expr' expr' in
+
+      if child = expr' then
+        (expr', expr_cxt_expect, expr_cxt_one)
+
+      else
+        match expr'.pexp_desc with
+
+        | Pexp_construct (lid, Some {pexp_desc = Pexp_tuple es}) ->
+
+           let child' =
+             List.fold_left comp_child (reset child) es in
+           if child' = reset child then
+             (expr', expr_cxt_expect, expr_cxt_one)
+
+           else
+             let expr_cxt_expect' e' =
+               {expr' with
+                 pexp_desc =
+                   Pexp_construct (lid, Some (expect child e'))
+               } |> expr_cxt_expect |> reset' (get_one e') in
+             getChild' expr_cxt_expect' expr_cxt_one child'
+
+        | _ ->
+           let expr_cxt_expect' e' =
+             expect expr' e' |> expr_cxt_expect |> reset' (get_one e') in
+           getChild' expr_cxt_expect' expr_cxt_one child in
+
+    getChild true getChild' resize expr
+
+  let getChild3 expr =
+
+    let n = get_one expr in
+
+    let rec resize expr =
+
+      if Desc.Exp.leaf expr || get 0 expr = 0 then expr
+
+      else if fltr0 expr then
+        let expr' = Desc.Exp.map resize expr in
+        reset' (Desc.Exp.fold get 1 expr') expr'
+
+      else
+        let children =
+          Desc.Exp.fold (
+              fun acc e ->
+              if hole_of_exp e = e then acc else e :: acc
+            ) [] expr in
+
+        match expr.pexp_desc with
+
+        | Pexp_apply (e, les) when children = [] ->
+
+           reset_hole
+             {expr with
+               pexp_desc =
+                 Pexp_apply
+                   (Hole.to_exp e,
+                    List.map (
+                        fun (l', e') -> (l', Hole.to_exp e')
+                      ) les)}
+
+         | _ ->
+            reset expr in
+
+    let expect' expr_cxt_expect expr' e' =
+      expect expr' e' |> expr_cxt_expect in
+
+    let comp_child exp' exp =
+      if 0 <= comp2 (n / 2) exp' exp && fltr0 exp then exp else exp'
+
+    and expr_cxt_one e' =
+      let slice =
+        Desc.Exp.map_all (
+            fun e ->
+            if e = e' then reset_hole e
+            else if Hole.check_loc e e' then e' else e
+          ) expr in
+      resize slice in
+
+    let rec getChild' expr_cxt_expect expr' =
+
+      let child = Desc.Exp.fold comp_child expr' expr' in
+
+      if child = expr' then
+        (expr', expr_cxt_expect, expr_cxt_one)
+
+      else
+        match expr'.pexp_desc with
+
+        | Pexp_fun _ when (
+          match child.pexp_desc with
+          | Pexp_fun _ -> true
+          | _ -> false) ->
+           (* fun文 *)
+           (child, expect' expr_cxt_expect expr', expr_cxt_one)
+
+        | Pexp_let (_, vs, _) when (
+          match child.pexp_desc with
+          | Pexp_fun _ -> List.exists (fun {pvb_expr} -> pvb_expr = child) vs
+          | _ -> false) ->
+           (* let文 *)
+           (child, expect' expr_cxt_expect expr', expr_cxt_one)
+
+        | Pexp_construct (lid, Some {pexp_desc = Pexp_tuple es}) ->
+           (* construct *)
+
+           let child' =
+             List.fold_left comp_child child es in
+           if child' = child then
+             (expr', expr_cxt_expect, expr_cxt_one)
+           else
+             let expr_cxt_expect' e' =
+               {expr' with
+                 pexp_desc =
+                   Pexp_construct (lid, Some (expect child e'))
+               } |> expr_cxt_expect in
+             getChild' expr_cxt_expect' child'
+
+        | _ ->
+           getChild' (expect' expr_cxt_expect expr') child in
+
+    getChild' resize expr
+
+
+  (* get_child : expression -> expression * (expression -> expression) *)
+  (* 式 expr のサイズ n の半分に最も近い子ノードを探す *)
+  let get_child =
+    if set_resize then get_childWithResize else get_childNoResize
+
+
+  (* size を与える関数 *)
+  (* set_one : ?n:int -> expression -> expression *)
+  let set_one ?(n = 1) slice =
+    if set_size then
+      (* Exp.attr slice (mknoloc "size", Size n) *)
+      let open Ast in
+      Exp.attr slice (mknoloc "size", PPat (Pat.constant (Const.int n), None))
+    else slice
+
+  (* set_all : ('a list -> 'a list -> expression ->
+                 ('a list -> expression -> expression_desc) -> expression)
+                -> ('a list -> expression -> expression_desc)
+                -> ('a -> expression) -> 'a list -> expression
+                -> expression *)
+  let set_all fp fd fx acc s_all =
+    if set_size then
+      let n = List.fold_left
+                (fun n x -> get n (fx x))
+                (get 1 s_all) acc in
+      set_one ~n (fp acc [] s_all fd)
+    else (fp acc [] s_all fd)
+
+  let compare_size m e1 e2 =
+    compare (abs (m - get 0 e1)) (abs (m - get 0 e2))
+
+  (* 親ノードのサイズを取得して、子ノードの式を半分に近い順に並び替える *)
+  let node_sort expr =
+
+    let m = (get 2 expr) / 2 in (* 親のサイズの半分 *)
+    let sort_size es = List.stable_sort (compare_size m) es in
+
+    match expr.pexp_desc with
+    | Pexp_ident _ | Pexp_constant _ -> sort_size [expr]
+
+    | Pexp_let (_, vs, e) ->
+       sort_size (e :: List.map (fun v -> v.pvb_expr) vs)
+    | Pexp_function (cs) ->
+       sort_size (List.map (fun c -> c.pc_rhs) cs)
+    | Pexp_fun (_, eop, _, e) ->
+       sort_size (match eop with None -> [e] | Some e' ->[e; e'])
+    | Pexp_apply (e, les) ->
+       sort_size (e :: List.map snd les)
+    | Pexp_match (e, cs) ->
+       sort_size (e :: List.map (fun c -> c.pc_rhs) cs)
+    | Pexp_try (e, cs) ->
+       sort_size (e :: List.map (fun c -> c.pc_rhs) cs)
+    | Pexp_tuple (es) -> sort_size es
+    | Pexp_construct (_, Some {pexp_desc = Pexp_tuple es}) -> sort_size es
+    | Pexp_construct (_, Some e) -> [e]
+    | Pexp_variant (_, Some e) -> [e]
+    | Pexp_record (les, eop) ->
+       sort_size ((List.map snd les)
+                  @ match eop with None -> [] | Some e -> [e])
+    | Pexp_field (e, _) -> [e]
+    | Pexp_setfield (e1, _, e2) -> sort_size [e1; e2]
+    | Pexp_array (es) -> sort_size es
+    | Pexp_ifthenelse (e1, e2, eop) ->
+       sort_size (e1 :: e2
+                  :: match eop with None -> [] | Some e3 -> [e3])
+    | Pexp_sequence (e1, e2) -> sort_size [e1; e2]
+    | Pexp_constraint (e, _) -> [e]
+    | Pexp_send (e, _) -> [e] 
+    | _ -> []
+*)
+end
+
+(*
+module Abst = struct
+  (* 抽象化 *)
+  module type Typ =
+    sig
+      type t
+      val hole : t -> t
+    end
+
+  module Exp = struct
+    type t = expression
+    let hole = Hole.of_exp
+  end
+
+(*
+
+  let rec slice_of_exp' expr =
+    let open Location in
+    let (filename', start_line', start_char') =
+      get_pos_info expr.pexp_loc.loc_start
+    and (_, end_line', end_char') =
+      get_pos_info expr.pexp_loc.loc_end  in
+
+    Format.fprintf ppf "@[(%s, %d, %d, %d, %d) <- %a@]@."
+      filename' start_line' start_char' end_line' end_char'
+      Pprintast.expression expr;
+
+    (* 該当する情報を探す *)
+    let {ghost = ghost'} =
+      List.find (fun {start_line; start_char;
+                      end_line; end_char;
+                      filename; ghost} ->
+          start_line = start_line'
+          && start_char = start_char'
+          && end_line = end_line'
+          && end_char = end_char'
+          && filename = filename'
+          && expr.pexp_loc.loc_ghost = (ghost mod 2 = 1)) !log.slice in
+    
+    match expr.pexp_desc with
+    | Pexp_construct (lid, Some ({pexp_desc = Pexp_tuple es} as e))
+         when e.pexp_loc.loc_ghost ->
+       
+       if 1 < ghost' then
+         let les =
+           Format.fprintf ppf "@[make dummy : %a@]@."
+             Pprintast.expression expr;
+           List.map (fun e -> (Nolabel, slice_of_exp e)) es in
+         {expr with
+           pexp_desc =
+             Pexp_apply (hole_of_exp expr, les)}
+       else
+         let e' =
+           Format.fprintf ppf "@[slice : %a@]@."
+             Pprintast.expression expr;
+           {e with pexp_desc =
+                     Pexp_tuple (List.map slice_of_exp es)} in
+         {expr with
+           pexp_desc =
+             Pexp_construct (lid, Some e')}
+         
+    | _ ->
+       Format.fprintf ppf "@[slice : %a@]@."
+         Pprintast.expression expr;
+       (* そのまま *)
+       Desc.Exp.map slice_of_exp expr
+
+  and slice_of_exp expr =
+    try
+      slice_of_exp' expr
+    with
+      Not_found ->
+      Format.fprintf ppf "@[hole : %a@]@."
+        Pprintast.expression expr;
+      hole_of_exp expr
+
+*)
+
+  let hole_of_x map1 x = map1 hole_of_exp Map.id x
+
+  (* set_one : slice -> slice list *)
+  (* 部分的に抽象化 *)
+  let set_one exp =
+
+    let sn n en sel = if sel = n then hole_of_exp en else en in
+
+    (* リストが構文中にない場合 *)
+    (* e が □ でなければ exp の desc を置き換えた要素を abst に追加 *)
+    let set_some e ?(abst = []) desc =
+      
+      if e = hole_of_exp e then abst
+      else abst @ [Desc.expression desc exp] in
+
+    (* リストが構文中にある場合 *)
+    (* 再帰で要素をひとつひとつ抽象化 *)
+    let set_one' ?(es = []) ?(e = skeleton') map1 fd xs =
+     
+      let to_exp fd e xs = Desc.to_exp fd xs e exp in
+      let fde acc = List.map (to_exp fd e) (List.rev acc) in
+      let dummy_apply es =
+        Desc.e_apply (List.map (fun e -> (Nolabel, e)) es) skeleton' in
+      let rec set_some' acc forward backword = match backword with
+       | [] -> fde acc
+       | tar :: backword' ->
+          (* チェック済 *)
+          let forward' = forward @ [tar] in
+          (* tar を□で置き換えることを試みる *)
+          let dummy = hole_of_x map1  tar in
+          let acc' =
+            if tar = dummy then acc
+            else (forward @ (dummy :: backword')) :: acc in
+          set_some' acc' forward' backword' in
+
+      set_some
+        e ~abst:(set_some' [] [] xs)
+        (if es = [] then fd xs (hole_of_exp e) else dummy_apply es) in
+    
+    (* abst_one のメイン部分 *)
+    match exp.pexp_desc with
+
+    | Pexp_let (flg, vs, e) ->
+       (* let 文 *)
+       (* let x = S1 in S2 => [let x = □ in S2; let x = S1 in □] *)
+       set_one' ~e Map.v1 (Desc.e_let flg) vs
+
+    | Pexp_apply (e, les) ->
+       (* 関数適用 *)
+       (* @ S1 .. Sn => [=@ S1..Sn; @ □..Sn; ...; @ S1..□]  *)
+       set_one' ~e Map.le Desc.e_apply les
+
+    | Pexp_function (cs) ->
+       (* function *)
+       (* function P1 -> S1 | ... | Pn -> Sn =>
+       [function P1 -> □ | ... ; function ... | Pn -> □] *)
+       set_one' Map.c1 Desc.e_function cs
+
+    | Pexp_fun (l, eop, p, e) ->
+       (* fun *)
+       (* λx.S => λx.□ *)
+      set_one' ~e Map.e1 (fun _ e -> Desc.e_fun l eop p e) []
+
+    | Pexp_match (e, cs) ->
+       (* match 文 *)
+       (* パターンする式と結果のみを対象にしている *)
+       (* match S0 with P1 -> S1 | ... | Pn -> Sn =>
+       [match □ with ...; ... with P1 -> □ | ...; ... with ... | Pn -> □] *)
+       set_one' ~e Map.c1 Desc.e_match cs
+                
+    | Pexp_try (e, cs) ->
+       (* try 文 *)
+       (* パターンする式と結果のみを対象にしている *)
+       (* try S0 with P1 -> S1 | ... | Pn -> Sn =>
+       [try □ with ...; ... with P1 -> □ | ...; ... with ... | Pn -> □] *)
+       set_one' ~e Map.c1 Desc.e_try cs
+                
+    | Pexp_tuple (es) ->
+       (* tuple *)
+       (* (S1, ... Sn) => [(□, ... Sn); ... ; (S1, ..., □); @= S1 ,..., Sn] *)
+       set_one' ~es Map.e1 Desc.e_tuple es
+                
+    | Pexp_construct (lid, Some (e)) ->
+       (* コンストラクタ *)
+       (* 引数が単数か複数かで分岐 *)
+       let es = match e.pexp_desc with
+           Pexp_tuple es -> es
+         | _ -> [] in
+       set_one' ~es ~e Map.e1 (Desc.e_construct lid) es
+                
+    | Pexp_record (les, eop) ->
+       (* record *)
+       (* 各フィールドを対象にしている *)
+       set_one'
+         ~e:(match eop with None -> skeleton' | Some e -> e)
+         Map.le Desc.e_record les
+         
+    | Pexp_field (e, lid) ->
+       set_one' ~e Map.e1 (Desc.e_field lid) []
+
+    | Pexp_setfield (e1, lid, e2) ->
+       let fd sel = Desc.e_setfield lid (sn 1 e1 sel) (sn 2 e2 sel) in
+       set_some ~abst:(set_some e1 (fd 1)) e2 (fd 2)
+
+    | Pexp_array (es) ->
+       (* array *)
+       set_one' ~es Map.e1 Desc.e_array es
+                
+    | Pexp_ifthenelse (e1, e2, eop) ->
+       (* ifthenelse *)
+       (* [if □ then e2 else e3;
+          if e1 then □ else e3;
+          if e1 then e2 else □] *)
+      let e3 = match eop with
+          Some e -> e | None -> skeleton' in
+      let fd sel = Desc.e_ifthenelse
+                     (sn 1 e1 sel) (sn 2 e2 sel)
+                     (if eop <> None && sel = 3
+                      then Some (hole_of_exp e3) else eop) in
+      set_some
+        ~abst:(set_some ~abst:(set_some e1 (fd 1)) e2 (fd 2)) e3 (fd 3)
+
+   | Pexp_sequence (e1, e2) ->
+      let fd sel = Desc.e_sequence (sn 1 e1 sel) (sn 2 e2 sel) in
+      set_some ~abst:(set_some e1 (fd 1)) e2 (fd 2)
+
+   | Pexp_constraint (e, c) ->
+      (* constraint *)
+      (* [(□ : c)] *)
+      set_one' ~e Map.e1 (Desc.e_constraint c) []
+
+   | _ -> if exp = hole_of_exp exp then [] else [hole_of_exp exp]
+
+  (* 部分式を全て抽象化 *)
+  let set_all exp =
+
+    let set_all' ?(e = skeleton') map1 fd xs =
+      Desc.to_exp fd (List.map (hole_of_x map1) xs) (hole_of_exp e) exp in
+    let set_all'' desc = Desc.expression desc exp in 
+
+    match exp.pexp_desc with
+
+    | Pexp_let (flg, vs, e) ->
+       set_all' ~e Map.v1 (Desc.e_let flg) vs
+
+    | Pexp_apply (e, les) ->
+       set_all' ~e Map.le Desc.e_apply les
+
+    | Pexp_function (cs) ->
+       set_all' Map.c1 Desc.e_function cs
+
+    | Pexp_fun (l, eop, p, e) ->
+       set_all'' (Desc.e_fun l eop p (hole_of_exp e))
+
+    | Pexp_match (e, cs) ->
+       set_all' ~e Map.c1 Desc.e_match cs
+
+    | Pexp_try (e, cs) ->
+       set_all' ~e Map.c1 Desc.e_try cs
+
+    | Pexp_tuple (es) ->
+       set_all' Map.e1 Desc.e_tuple es
+
+    | Pexp_construct (lid, Some e) ->
+       let es = match e.pexp_desc with
+           Pexp_tuple es -> es | _ -> [] in
+       set_all' ~e Map.e1 (Desc.e_construct lid) es
+
+    | Pexp_record (les, eop) ->
+       set_all' ~e:(match eop with None -> skeleton' | Some e -> e)
+                Map.le Desc.e_record les
+
+    | Pexp_field (e, lid) ->
+       set_all' ~e Map.e1 (Desc.e_field lid) []
+
+    | Pexp_array (es) ->
+       set_all' Map.e1 Desc.e_array es
+
+    | Pexp_ifthenelse (e1, e2, eop) ->
+       set_all'' (
+           Desc.e_ifthenelse (hole_of_exp e1)
+                             (hole_of_exp e2)
+                             (match eop with Some e3 -> Some (hole_of_exp e3)
+                                           | None -> None))
+
+    | Pexp_sequence (e1, e2) ->
+       set_all'' (
+           Desc.e_sequence (hole_of_exp e1)
+                           (hole_of_exp e2))
+
+    | Pexp_constraint (e, ct) ->
+       set_all' ~e Map.e1 (Desc.e_constraint ct) []
+
+    | d -> set_all'' d
+
+  (* Abst.one, Abst.all *)
+
+  let one expr =
+    (* 既に確定している場合は抽象化しない *)
+    if Size.fltr0 expr then Size.terminated (hole_of_exp expr) else expr
+
+  let all expr = Size.terminated (Desc.Exp.map one expr)
+
+  let set slice expr =
+    if Hole.check_loc slice expr then slice else expr
+
+  let get' sel slice expr =
+
+    if Hole.check_loc slice expr = sel then
+      (* sel = true : loc = true *)
+      (* sel = false : loc = false *)
+      (* expr を抽象化 *)
+      one expr
+    else
+      set slice expr
+
+  (* Abst.get *)
+  let get expr sel slice =
+    (if Hole.check_skeleton slice then
+       if sel then Size.terminated else all
+     else
+       Desc.Exp.map (
+           (if Size.comp1 slice < 0 then set else get' sel)
+             slice)) expr
+
+
+  let exp e =
+    if Size.fltr0 e then
+      (hole_of_exp e)
+      |> (if Size.set_resize then Size.reset else Size.terminated)
+    else e;
+
+end
+*)
+
+(* デバッグ用 *)
+module Meta = struct
+  (* 型デバッガが訪れるノード数カウント用の変数 (debug_main.ml) *)
+  open Ast
+  let visible = false
+
+  let clean' name expr =
+    {expr with
+      pexp_attributes =
+        if name = "all" then [] (* 全部消す *)
+        else
+          List.filter (
+              fun {attr_name = {txt = name'}} ->
+              name <> name'
+            ) expr.pexp_attributes}
+
+  let clean name expr =
+    Desc.Exp.map_all (clean' name) expr
+
+
+  let rec attribute ppf (kind, attrs) = match attrs with
+      [] -> ()
+    | {attr_name = {txt = s};
+       attr_payload = PPat ({ppat_desc = Ppat_constant (Pconst_integer (n, None))}, None)} :: _
+         when s = kind ->
+       (* 【新バージョン】 *)
+       Format.fprintf ppf "(size : %s)" n
+
+    | {attr_name = {txt = s};
+       attr_payload = PStr [{pstr_desc = Pstr_eval (e, _)}]} :: _
+         when s = kind ->
+       (* 式のホール □ *)
+       if visible then Format.fprintf ppf "【%a】" Pprintast.expression e
+       else Format.fprintf ppf "□"
+    | {attr_name = {txt = s}; attr_payload = PPat (p, _)} :: _ when s = kind ->
+       (* パターンのホール ■ *)
+       if visible then Format.fprintf ppf "【%a】" Pprintast.pattern p
+       else Format.fprintf ppf "■"
+(*  | {attr_name = {txt = s}; attr_payload = Size n} :: _ when s = kind ->
+       (* サイズ *)
+       Format.fprintf ppf "(size : %d)" n *)
+    | _ :: rest-> attribute ppf (kind, rest)
+
+  (* 表示 *)
+  (* expression -> unit *)
+  and expression ppf ({pexp_desc = d; pexp_attributes = attrs} as exp) =
+    match d with
+    | Pexp_let (flg, vs, e) -> pexp_let ppf (flg, vs, Some (e))
+    | Pexp_fun (_, _, p, e) -> pexp_fun ppf (p, e)
+    | Pexp_apply (e, les) -> pexp_apply ppf (e, les)
+    | Pexp_match (e, cs) -> pexp_match ppf (e, cs)
+    | Pexp_try (e, cs) -> pexp_try ppf (e, cs)
+    | Pexp_tuple es -> pexp_tuple ppf es
+    | Pexp_construct (lid, Some (e)) -> pexp_construct ppf (lid, e)
+    | Pexp_record (les, _) -> pexp_record ppf les
+    | Pexp_array (es) -> pexp_array ppf es
+    | Pexp_ifthenelse (e1, e2, eop) -> pexp_ifthenelse ppf (e1, e2, eop)
+    | Pexp_sequence (e1, e2) -> pexp_sequence ppf (e1, e2)
+    | _ -> if exp = hole_of_exp exp then attribute ppf ("exp", attrs)
+           else Pprintast.expression ppf (Exp.mk d)
+
+  and value_binding ppf {pvb_pat = pn; pvb_expr = en} = match en.pexp_desc with
+    | Pexp_fun (_, _, p, e) ->
+       Format.fprintf ppf "%a %a"
+                      pattern pn
+                      value_binding (Vb.mk p e)
+    | _ ->
+       Format.fprintf ppf "%a = %a"
+                      pattern pn
+                      expression en
+
+
+  and cases ppf cs =
+    let case ppf {pc_lhs = pn; pc_guard = gn; pc_rhs = en} = match gn with
+      | None ->
+         Format.fprintf ppf "| %a -> %a"
+                        pattern pn
+                        expression en
+      | Some (e) ->
+         Format.fprintf ppf "| %a when %a -> %a"
+                        pattern pn
+                        expression e
+                        expression en in
+    List.iter (fun c -> Format.fprintf ppf "%a" case c) cs
+
+  and field_and_exp ppf (l, e) =
+    Format.fprintf ppf "%s = %a; "
+                   (Longident.last l.txt)
+                   expression e
+
+  and es_tl ppf (s, tl) =
+    List.iter (
+        fun en ->
+        Format.fprintf ppf "%s %a" s
+                       expression en) tl
+
+  and pexp_let ppf (flg, vs, eop) = match vs with
+      [] -> assert false
+    | first :: rest ->
+       let vb_hd ppf hd =
+         Format.fprintf ppf (if flg = Recursive
+                             then "let rec %a"
+                             else "let %a") value_binding hd in
+       let vb_tl ppf tl =
+         List.iter (
+             fun vn ->
+             Format.fprintf ppf " and %a" value_binding vn) tl in
+       match eop with
+       | None ->
+          Format.fprintf ppf "%a %a"
+                         vb_hd first
+                         vb_tl rest
+       | Some (e) ->
+          Format.fprintf ppf "%a %a in %a"
+                         vb_hd first
+                         vb_tl rest
+                         expression e
+
+  and pexp_fun ppf (p, e) =
+    Format.fprintf ppf "(fun %a -> %a)"
+                   pattern p
+                   expression e
+
+  and pexp_apply ppf (e, les) =
+    let args ppf les =
+      List.iter (fun (_, e) -> Format.fprintf ppf " %a" expression e) les in
+    Format.fprintf ppf "(%a%a)"
+                   expression e
+                   args les
+
+  and pexp_match ppf (e, cs) =
+    Format.fprintf ppf "match %a with %a"
+                   expression e
+                   cases cs
+
+  and pexp_try ppf (e, cs) =
+    Format.fprintf ppf "try %a with %a"
+                   expression e
+                   cases cs
+
+  and pexp_tuple ppf es = match es with
+      [] -> assert false
+    | first :: rest ->
+       Format.fprintf ppf "(%a%a)"
+                      expression first
+                      es_tl (",", rest)
+
+  and pexp_construct ppf (lid, e) = (* 要素ありのみ *)
+    Format.fprintf ppf "(%s %a)"
+                   (Longident.last lid.txt)
+                   expression e
+
+  and pexp_record ppf les =
+    Format.fprintf ppf "{%a}"
+                   (fun ppf les ->
+                     List.iter (field_and_exp ppf) les) les
+
+  and pexp_array ppf es = match es with
+      [] -> Format.fprintf ppf "[||]"
+    | first :: rest ->
+       Format.fprintf ppf "[|%a%a|]"
+                      expression first
+                      es_tl (";", rest)
+
+  and pexp_ifthenelse ppf (e1, e2, eop) = match eop with
+    | None ->
+       Format.fprintf ppf "@if %a then %a"
+                      expression e1
+                      expression e2
+    | Some (e3) ->
+       Format.fprintf ppf "if %a then %a else %a"
+                      expression e1
+                      expression e2
+                      expression e3
+
+  and pexp_sequence ppf (e1, e2) =
+    Format.fprintf ppf "(%a; %a)"
+                   expression e1
+                   expression e2
+    
+
+  and pattern ppf ({ppat_desc = d; ppat_attributes = attrs} as pat) =
+    match d with
+    | Ppat_tuple ps -> ppat_tuple ppf ps
+    | Ppat_construct (lid, Some (p)) -> ppat_construct ppf (lid, p)
+    | Ppat_record (lps, _) -> ppat_record ppf lps
+    | _ -> if pat = hole_of_pat pat then attribute ppf ("pat", attrs)
+           else Pprintast.pattern ppf pat
+
+  and ppat_tuple ppf ps = match ps with
+      [] -> assert false
+    | first :: rest ->
+       Format.fprintf
+         ppf "(%a%a)"
+         pattern first
+         (fun ppf ps ->
+           List.iter (Format.fprintf ppf ", %a" pattern) ps) rest
+
+  and ppat_construct ppf (lid, p) = (* 要素ありのみ *)
+    Format.fprintf ppf "(%s %a)"
+                   (Longident.last lid.txt)
+                   pattern p
+
+  and ppat_record ppf lps =
+    Format.fprintf ppf "{%a}"
+                   (fun ppf lps ->
+                     List.iter (field_and_pat ppf) lps) lps
+
+  and field_and_pat ppf (l, p) =
+    Format.fprintf ppf "%s = %a; "
+                   (Longident.last l.txt) pattern p
+
+  let rec structure ppf str = match str with
+    | [] -> ()
+    | ({pstr_desc = d} as first) :: rest ->
+       (* first の表示 *)
+       if first <> hole_str then
+         match d with
+         | Pstr_eval (e, _) ->
+            Format.fprintf ppf "@[%a@]@." expression e
+         | Pstr_value (flg, vs) ->
+            Format.fprintf ppf "@[%a@]@." pexp_let (flg, vs, None)
+         | _ ->
+            Format.fprintf ppf "@[%a@]@." Pprintast.structure [first]
+       else Format.fprintf ppf "@[(The mark '□' is a hole expression.)@]@.";
+       (* rest について再帰 *)
+       Format.fprintf ppf "@[%a@]@." structure rest
+
+  (* デバッグ用 expression の print *)
+  let print_deb_exp ppf exp =
+    Format.fprintf ppf "%a %a"
+                   expression exp
+                   attribute ("size", exp.pexp_attributes)
+  let print_deb_strs ppf strs = Format.fprintf ppf "%a"structure strs
+
+end
+
+(* 抽象：変数 *)
+let skeleton = Hole.dummy_assertfalse ()
+let wildcard = Hole.dummy_any ()
+let dummy_int0 = Hole.dummy_int0 ()
+let dummy_fun = Hole.dummy_fun ()
+(* 抽象化：関数 *)
+let dummy_assertfalse exp = Hole.expression exp
+let dummy_any pat = Hole.pattern pat
+
+(* デバッグ用：変数 *)
+(* スライスの切り替え *)
+let on_slice = on_exp_slice
+let on_pat_slice = on_pat_slice
+(* デバッグ用：関数 *)
+let print_deb_exp ppf exp = Meta.print_deb_exp ppf exp
+let print_deb_strs ppf strs = Meta.print_deb_strs ppf strs
+
+(* ---------------------------------------------------------- *)
+(* 構文の生成 *)
+
+(* 元の構文の desc を置き換える *)
+let desc_to_exp = Desc.expression
+let desc_to_pat = Desc.pattern
+
+(* ---------------------------------------------------------- *)
+
+
+(*
+module Library =
+  struct
+
+    module Locations = struct
+      module type Typ =
+        sig
+          type s
+          val internal : s -> s -> bool
+          val pos_start : s -> string * (int * int)
+          val pos_end : s -> string * (int * int)
+          val pos_ghost : s -> bool
+          val pos_all : s -> (string * ((int * int) * (int * int))) * bool
+        end
+
+      open Location
+
+      let internal to_loc root node =
+        let {loc_start = root_s; loc_end = root_e} = to_loc root
+        and {loc_start = node_s; loc_end = node_e} = to_loc node in
+
+        root_s <= node_s && node_e <= root_e
+
+      let pos_start to_loc a =
+        let loc = to_loc a in
+        let (filename, line, char) =
+          get_pos_info loc.loc_start in
+        (filename, (line, char))
+
+      let pos_end to_loc a =
+        let loc = to_loc a in
+        let (filename, line, char) =
+          get_pos_info loc.loc_end in
+        (filename, (line, char))
+
+      let pos_ghost to_loc a =
+        let loc = to_loc a in
+        loc.loc_ghost
+
+      let pos_all to_loc a =
+        let (filename, s_pair) = pos_start to_loc a
+        and (filename', e_pair) = pos_end to_loc a in
+
+        (* ファイル名は同じになる *)
+        assert (filename = filename');
+        ((filename, (s_pair, e_pair)), pos_ghost to_loc a)
+
+    end
+
+    module type Abst_t =
+      sig
+        type t
+        val skeleton : t
+        val terminate : t -> t
+
+        val of_desc : t -> t
+        val of_attr : t -> t
+        val to_loc : t -> Location.t
+      end
+
+    module type Modules =
+      sig
+        include Locations.Typ
+
+        val print : bool -> Format.formatter -> s -> unit
+
+        module Desc : Desc.Typ with type t = s
+
+
+        module Hole : sig
+          include Abst_t with type t = s
+          val root : s -> s
+          val node : s -> s
+        end
+
+      end
+
+    type 'a abst_t = (module Abst_t with type t = 'a)
+    type 'a desc_t = (module Desc.Typ with type t = 'a)
+
+    let make (type a) print (abst : a abst_t) (desc : a desc_t) =
+      let (module A) = abst in
+      let (module D) = desc in
+
+      (module
+         struct
+           type s = a
+
+           let print = print
+           let internal root node =
+             Locations.internal A.to_loc root node
+           let pos_start a = Locations.pos_start A.to_loc a
+           let pos_end a = Locations.pos_end A.to_loc a
+           let pos_ghost a = Locations.pos_ghost A.to_loc a
+           let pos_all a = Locations.pos_all A.to_loc a
+
+           module Desc = D
+           module Hole = struct
+             include A
+             let root e = of_desc e
+             let node e = of_attr (D.map of_desc e)
+           end
+         end : Modules with type s = a)
+
+    let expression =
+      make
+        (fun debug ->
+          if debug then
+            print_deb_exp
+          else
+            Pprintast.expression)
+        (module
+           struct
+             type t = expression
+             let skeleton = skeleton
+             let terminate e =
+               let attr =
+                 ({txt = "term"; loc = e.pexp_loc}, PPat (wildcard, None)) in
+               Exp.attr e attr
+
+             let of_desc e = hole_of_exp e
+             let of_attr e = {e with pexp_attributes = []}
+             let to_loc e = e.pexp_loc
+           end)
+        (module Desc.Exp)
+
+  end
+*)
+module Data = struct
+
+  let is_toplevel = Array.length Sys.argv < 2
+
+  let log_path =
+    try
+      Sys.getenv "DEBUGGER_LOG_PATH"
+    with
+      Not_found -> "."
+  let express_mode =
+    try
+      int_of_string (Sys.getenv "DEBUGGER_EXPRESS_MODE")
+    with
+      _ -> -1
+
+  let makeOpenOut path =
+    open_out_gen [Open_append; Open_creat] 420 path
+
+  module Loc = struct
+    open Location
+
+    type t = {filename : string;
+              s_line : int; s_char : int;
+              e_line : int; e_char : int; }
+
+    let to_filename name =
+      try
+        assert (name <> "//toplevel//" && log_path <> ".");
+        let ld_len = String.length log_path + 1 in
+        let fn_len = String.length name in
+
+        Format.sprintf "%s"
+          (String.sub name ld_len (fn_len - ld_len))
+      with
+        _ -> name
+
+    let of_location loc =
+      let (filename, s_line, s_char) = get_pos_info loc.loc_start
+      and (filename', e_line, e_char) = get_pos_info loc.loc_end in
+      assert (filename = filename');
+      {filename; s_line; s_char; e_line; e_char}
+
+    let flat_string loc =
+      (* filename,
+         loc_start.line, loc_start.char,
+         loc_end.start, loc_end.char *)
+      let (filename, s_line, s_char) = get_pos_info loc.loc_start
+      and (filename', e_line, e_char) = get_pos_info loc.loc_end in
+      assert (filename = filename');
+
+      Format.sprintf "%s,%d,%d,%d,%d"
+        (to_filename filename) s_line s_char e_line e_char
+
+    let dual_string loc1 loc2 =
+      let str1 = of_location loc1 and str2 = of_location loc2 in
+      assert (str1.filename = str2.filename);
+      Format.sprintf "%s,%s"
+        (flat_string loc1) (flat_string loc2)
+
+    let is_ghost loc = loc.loc_ghost
+
+    let printJSON ppf loc =
+      let open Location in
+      let (s_file, s_line, s_char) =
+        get_pos_info loc.loc_start
+      and (e_file, e_line, e_char) =
+        get_pos_info loc.loc_end in
+      Format.fprintf ppf
+        "{\"s\": {\"file\":\"%s\", \"line\":%d, \"char\":%d},\"e\": {\"file\":\"%s\", \"line\":%d, \"char\":%d}}"
+        (to_filename s_file) s_line s_char
+        (to_filename e_file) e_line e_char
+
+    let read line =
+
+      let n = String.index_from line 0 ',' in
+
+      let filename =
+        match String.sub line 0 n with
+        filename' -> 
+          assert (filename' <> "//toplevel//");
+          log_path ^ "/" ^ filename' in
+
+      let line = String.sub line (n + 1) (String.length line - n - 1) in
+
+      let n = String.index_from line 0 ',' in
+      let s_line = String.sub line 0 n |> int_of_string in
+
+      let line = String.sub line (n + 1) (String.length line - n - 1) in
+
+      let n = String.index_from line 0 ',' in
+      let s_char = String.sub line 0 n |> int_of_string in
+
+      let line = String.sub line (n + 1) (String.length line - n - 1) in
+
+      let n = String.index_from line 0 ',' in
+      let e_line = String.sub line 0 n |> int_of_string in
+
+      let line = String.sub line (n + 1) (String.length line - n - 1) in
+
+      let n = String.index_from line 0 ',' in
+      let e_char = String.sub line 0 n |> int_of_string in
+
+      {filename; s_line; s_char; e_line; e_char; },
+      (String.sub line (n + 1) (String.length line - n - 1))
+
+  end
+
+  type opt =
+    | Buffer of (string option * bool) list
+    | Slice of int
+
+  module Buffer = struct
+    let path = log_path ^ "/buffer.csv"
+
+    (* 読み込み *)
+    let read' loc (scope, ans) list = match list with
+      | (loc', Buffer ((scope', ans') :: rest')) :: rest
+        when loc = loc' (* 同じ式が対象 *) ->
+          (loc, Buffer ((scope, ans) :: (scope', ans') :: rest')) :: rest
+      | _ ->
+          (loc, Buffer [(scope, ans)]) :: list
+
+    let rec read file list =
+      try
+        let line = input_line file in
+
+        if print_slice then
+          Format.fprintf ppf "@[Buffer read : %s@]@." line;
+
+        let (loc, line) = Loc.read line in
+
+        let n = String.index_from line 0 ',' in
+        let ans = String.sub line 0 n = "y" in
+        let scope =
+          let name =
+            String.sub line (n + 1) (String.length line - n - 1) in
+          if name = "" then None else Some name in
+        read file (read' loc (scope, ans) list)
+      with End_of_file -> close_in file; list
+         | _ -> read file list
+
+    (* 書き込み *)
+    let write scope expr ans =
+     if on_file_output then begin
+      let line = Loc.flat_string expr.pexp_loc in
+      let file = makeOpenOut path in
+      (* 回答、スコープ、位置情報 *)
+      if Array.length Sys.argv = 8 then
+        Format.fprintf ppf "{\"location\":%a, \"scope\":%s}"
+          Loc.printJSON expr.pexp_loc (if scope = "" then "null" else ("\"" ^ scope ^ "\""));
+
+      if ans = "y" || ans = "n" then
+        output_string file
+          (Format.sprintf "%s,%s,%s\n"
+             line ans scope);
+      close_out file
+     end
+
+    let rec set'' name cxt = match cxt with
+      | Lambda (p, cxt') ->
+         let p' = Desc.Pat.find name p in
+         if p' = wildcard then set'' name cxt' else p'
+      | Let (_, vs, cxt') ->
+          let p' =
+            List.fold_left (
+              fun p'' {pvb_pat} ->
+                if p'' = wildcard then
+                  Desc.Pat.find name pvb_pat
+                else
+                  p''
+              ) wildcard vs in
+          if p' = wildcard then set'' name cxt' else p'
+      | _ -> wildcard
+
+    let set' cxt expr (scope, ans) =
+      let pat = match scope with
+          None -> wildcard
+        | Some name ->
+           if print_slice then
+             Format.fprintf ppf "@[scope: %s@]@." name;
+           set'' name cxt in
+      {attr_name = {txt = if ans then "yes" else "no"; loc = expr.pexp_loc};
+       attr_payload = PPat (pat, None);
+       attr_loc = Location.none}
+
+    let set cxt asks expr =
+      let cxt' =
+        match expr.pexp_desc with
+        | Pexp_fun (_, _, p, _) ->
+           if print_slice then
+             Format.fprintf ppf "@[lambda.%a@]@." Pprintast.pattern p;
+           Lambda (p, cxt)
+        | Pexp_let (flg, vs, _) ->
+           if print_slice then
+             Format.fprintf ppf "@[let%a@]@."
+               (fun ppf ->
+                 List.iter (fun vb ->
+                   Format.fprintf ppf ".%a"
+                     Pprintast.pattern vb.pvb_pat)) vs;
+           Let (flg, vs, cxt)
+        | _ -> cxt in
+      ({expr with pexp_attributes = List.map (set' cxt' expr) asks}, cxt')
+(*
+    open Location
+    let printJSON ppf loc =
+      let (s_file, s_line, s_char) =
+        get_pos_info loc.loc_start
+      and (e_file, e_line, e_char) =
+        get_pos_info loc.loc_end in
+      Format.fprintf ppf
+        "{\"s\": {\"file\":\"%s\", \"line\":%d, \"char\":%d},\"e\": {\"file\":\"%s\", \"line\":%d, \"char\":%d}}"
+        s_file s_line s_char e_file e_line e_char
+
+    let json ppf loc =
+      Format.fprintf ppf
+        "\"location\": %a"
+        printJSON loc
+*)
+  end
+  module Slice = struct
+
+    (* ファイルのパス *)
+    let path = log_path ^ "/slice.csv"
+
+    module Exp = struct
+
+      let slices = ref []
+      let lines = ref []
+
+      (* 読み込み *)
+      let rec read file list =
+        try
+          let line = input_line file in
+
+          let (loc, opt') = Loc.read line in
+
+          read file ((loc, Slice (int_of_string opt')) :: list)
+        with
+          End_of_file -> close_in file; list
+        | _ -> read file list
+
+      let outputs () =
+        let file = makeOpenOut path in
+        List.iter (output_string file) !lines
+
+      let rec set' expr es =
+        {expr with
+         pexp_desc =
+           Pexp_apply (hole_of_exp expr,
+                       List.map (fun e -> (Nolabel, e)) es)}
+
+      and set expr = match expr.pexp_desc with
+          Pexp_construct (_, Some {pexp_desc = Pexp_tuple es}) ->
+            set' expr es
+        | _ -> expr
+
+      let write' expr n =
+        (* 書き込み *)
+        if print_slice then
+          Format.fprintf ppf "@[write from: %a@]@." print_deb_exp expr;
+
+        let line =
+          Format.sprintf "%s,%d\n"
+            (Loc.flat_string expr.pexp_loc) n in
+
+        if print_slice then
+          Format.fprintf ppf "@[write to: %s@]@." line;
+
+        lines := !lines @ [line]
+
+      (* expr の位置情報を出力 *)
+      let write expr =
+        let ghost = Loc.is_ghost expr.pexp_loc in
+
+        match expr.pexp_desc with
+        | Pexp_apply (e, _) ->
+
+            if e = skeleton' then
+              (* nested apply *)
+              List.iter (
+                fun {attr_name = {txt}; attr_payload = payload} ->
+                  match payload with
+                    PStr structure when txt = "app" ->
+                      List.iter (
+                        fun item ->
+                          match item.pstr_desc with
+                            Pstr_eval (expr', _) ->
+                              if ghost then
+                                write' expr' 3
+                              else
+                                write' expr' 2
+                          | _ -> ()
+                      ) structure
+                  | _ -> ()
+              ) expr.pexp_attributes
+            else if ghost && expr.pexp_loc = e.pexp_loc then
+              (* dummy apply and ghost *)
+              write' expr 3
+            else if expr.pexp_loc = e.pexp_loc then
+              (* dummy apply *)
+              write' expr 2
+            else if ghost then
+              (* ghost *)
+              write' expr 1
+            else
+              (* others *)
+              write' expr 0
+
+        | _ ->
+            if ghost then
+              (* ghost *)
+              write' expr 1
+            else
+              (* others *)
+              write' expr 0
+
+      let clean ?(output = false) expr =
+        let cnt' = ref 0 in
+        let expr' =
+          Desc.Exp.map_all (
+            fun e ->
+              let e' = {e with pexp_attributes = []} in
+              if hole_of_exp e <> e then
+                (* hole 以外を追加 *)
+                if output then
+                  write e
+                else if output then
+                  cnt' := 1 + !cnt';
+              e'
+          ) expr in
+
+        (* 重複がなかった場合のみ追加 *)
+        if not (List.exists (fun (_, e) -> e = expr') !slices) then
+          slices := (!cnt', expr') :: !slices;
+        expr'
+
+    end
+
+  end
+
+  (* スライスを作るかどうか *)
+  let check_make_slice () =
+    (not (Sys.file_exists Slice.path))
+    && (not (Sys.file_exists Buffer.path))
+
+
+  (* 型推論の情報 *)
+  module Infer = struct
+    let path = log_path ^ "/infer.txt"
+
+    let root = ref Location.none
+    let cntItem = ref 0
+    let cntExpr = ref 0
+
+    (* 初期状態 *)
+    let init name =
+      if on_file_output && print_slice && check_make_slice () then
+        let file = makeOpenOut path in
+        output_string file
+          (Format.sprintf "(* %s slicer *)\n" name);
+        close_out file
+
+    (* root の位置情報を記録 *)
+    let read loc = root := loc
+
+    (* 外部ファイルへの書き込み *)
+    let write structure expr b =
+      if structure = [] && b then
+        let slice = Slice.Exp.clean ~output:(
+            check_make_slice ()
+          ) expr in
+        begin
+          if on_file_output && print_slice && check_make_slice () then
+            let file = makeOpenOut path in
+            Format.fprintf ppf "@[return: %a @]@."
+              print_deb_exp expr;
+            (* expression の出力 *)
+            output_string file
+              (Format.sprintf "\n(* infer %d.%d: end *)\n"
+                 !cntItem !cntExpr);
+            output_string file
+              (Format.sprintf "(* %s *)\n"
+                 (Pprintast.string_of_expression slice));
+            close_out file
+        end
+      else if structure = [] &&
+              (on_file_output && print_slice && check_make_slice ()) then
+        begin
+          let file = makeOpenOut path in
+          Format.fprintf ppf "@[origin: %a @]@."
+            print_deb_exp expr;
+          output_string file
+            (Format.sprintf "\n(* infer %d.%d: begin *)\n"
+               !cntItem !cntExpr);
+          output_string file
+            (Format.sprintf "(* %s *)\n"
+               (expr |> Pprintast.string_of_expression));
+        end
+      else if on_file_output && print_slice && check_make_slice () then
+        (* structure の出力 *)
+        begin
+          let file = makeOpenOut path in
+          match !Slice.Exp.slices with
+            [] -> ()
+          | (first, _) :: _ ->
+              Format.fprintf ppf "    @[%s(%d): %a @]@."
+                (if b then "welltyped" else "illtyped")
+                first
+                print_deb_exp expr;
+              let item =
+                List.find (
+                  fun item -> Desc.internal item.pstr_loc expr.pexp_loc
+                ) structure in
+              output_string file
+                (Format.sprintf "\n(* infer %d.%d: %s (%d) *)\n"
+                   !cntItem !cntExpr
+                   (if b then "welltyped" else "illtyped")
+                   first);
+              output_string file
+                (Format.sprintf "(* %s *)\n"
+                   (Slice.Exp.clean expr |> Pprintast.string_of_expression));
+              output_string file
+                (Format.sprintf "%s\n"
+                   ([item] |> Pprintast.string_of_structure))
+        end;
+
+      if structure = [] && b then
+        (cntExpr := 0; cntItem := !cntItem + 1)
+      else
+        cntExpr := !cntExpr + 1
+
+  end
+
+  (* 式の生成 *)
+  let rec init''' expr = match expr.pexp_desc with
+    | Pexp_apply (e, (_, {pexp_desc = Pexp_apply (e', les')}) :: les)
+      when e.pexp_desc = skeleton'.pexp_desc
+        && e'.pexp_desc = skeleton'.pexp_desc ->
+        if print_slice then
+          Format.fprintf ppf "@[nested : %a@]@."
+            print_deb_exp expr;
+        let les'' =
+          List.fold_left (
+            fun acc (l_, e_) ->
+              if e_ = hole_of_exp e_ then
+                acc
+              else
+                (acc @ [(l_, e_)])
+          ) [] (les' @ les) in
+        {expr with pexp_desc = Pexp_apply (skeleton', les'')}
+
+    | _ -> expr
+
+  and init'' kind cxt list opt expr =
+
+    let f c e = Desc.Exp.map (init' kind c list) e in
+
+    match opt with
+      Buffer asks ->
+        (* buffer の設定 *)
+        (* 複数ある可能性も考慮 *)
+        if print_slice then
+          Format.fprintf ppf "@[Buffer : %a@]@."
+            Pprintast.expression expr;
+        let (expr', cxt') = Buffer.set cxt asks expr in
+        init' kind cxt' (
+            List.filter (
+                fun (loc', opt') ->
+                loc' <> Loc.of_location expr.pexp_loc
+                || opt <> opt'
+              ) list) expr'
+    | Slice ghost ->
+        match expr.pexp_desc with
+        | Pexp_fun (_, _, p, _) ->
+            let cxt' = Lambda (p, cxt) in
+            f cxt' expr
+
+        | Pexp_let (flg, vs, e0) ->
+            let cxt' = Let (flg, vs, cxt) in
+            Desc.Exp.map (
+              fun e ->
+                if e = e0 then
+                  f cxt' e
+                else
+                  f cxt e
+            ) expr
+
+        | Pexp_tuple es
+          when 1 < ghost ->
+            if print_slice then
+              Format.fprintf ppf "@[Tuple : %a@]@."
+                Pprintast.expression expr;
+
+            let les =
+              List.fold_left (
+                fun acc e ->
+                  let e' = init' kind cxt list e in
+                  if e'.pexp_desc = skeleton'.pexp_desc then
+                    (* 抽象化されたので残さない *)
+                    acc
+                  else
+                    (acc @ [Nolabel, e'])
+              ) [] es in
+
+            init'''
+              {expr with
+               pexp_desc =
+                 Pexp_apply (skeleton', les)}
+
+        | Pexp_construct (_, Some {pexp_desc = Pexp_tuple es})
+          when 1 < ghost ->
+            if print_slice then
+              Format.fprintf ppf "@[Construct : %a@]@."
+                Pprintast.expression expr;
+
+            let les =
+              List.fold_left (
+                fun acc e ->
+                  let e' = init' kind cxt list e in
+                  if e'.pexp_desc = skeleton'.pexp_desc then
+                    (* 抽象化されたので残さない *)
+                    acc
+                  else
+                    (acc @ [Nolabel, e'])
+              ) [] es in
+
+            init'''
+              {expr with
+               pexp_desc =
+                 Pexp_apply (skeleton', les)}
+
+          | Pexp_construct (lid, Some ({pexp_desc = Pexp_tuple _} as e)) ->
+              (* コンストラクタ : タプル内の要素のみを処理 *)
+              {expr with
+               pexp_desc =
+                 Pexp_construct (lid, Some (f cxt (Slice.Exp.set e)))}
+
+          | Pexp_apply (_, les) when 1 < ghost ->
+              (* 関数適用 : 入れ子の判定に進む *)
+              if print_slice then
+                Format.fprintf ppf "@[Apply : %a@]@."
+                  Pprintast.expression expr;
+
+              let les' =
+                List.fold_left (
+                  fun acc (l, e) ->
+                    let e' = init' kind cxt list e in
+                    if e'.pexp_desc = skeleton'.pexp_desc then
+                      (* 抽象化されたので残さない *)
+                      acc
+                    else
+                      (acc @ [l, e'])
+                ) [] les in
+
+              init'''
+                {expr with
+                 pexp_desc =
+                   Pexp_apply (skeleton', les')}
+
+          | _ ->
+              (* その他 *)
+              if print_slice then
+                Format.fprintf ppf "@[Slice : %a@]@."
+                  Pprintast.expression expr;
+              if ghost < 2 then
+                f cxt (Slice.Exp.set expr)
+              else
+                init''' expr
+
+  and init' kind cxt list expr =
+    try
+      let (_, opt) =
+        List.find (
+            fun (loc, _) ->
+            loc = Loc.of_location expr.pexp_loc
+        ) list in
+      init'' kind cxt list opt expr
+    with
+      Not_found ->
+        if kind then
+          begin
+            if print_slice then
+              Format.fprintf ppf "@[hole : %a@]@."
+                print_deb_exp expr;
+            hole_of_exp expr
+          end
+        else if Desc.Exp.leaf expr then
+          expr
+        else
+          Desc.Exp.map (init' kind cxt list) expr
+
+  let init ((expr, cxt), env, prefix) =
+
+    if check_make_slice () || is_toplevel then
+      Size.Exp.set_and
+        (fun e -> Desc.Exp.complete ((e, cxt), env, prefix)) expr
+
+    else
+      let expr =
+        if Sys.file_exists Slice.path then
+          let file = open_in Slice.path in
+          init' true Empty (Slice.Exp.read file []) expr
+        else
+          expr in
+      let expr =
+        if Sys.file_exists Buffer.path then
+          let file = open_in Buffer.path in
+          init' false Empty (Buffer.read file []) expr
+        else
+          expr in
+      expr
+
+  let typed'' expr tp time =
+    let loc = !Infer.root in
+    if on_file_output && loc <> Location.none && check_make_slice () then
+      let file =
+        makeOpenOut (log_path ^ "/data.csv") in
+      let line =
+        Format.sprintf "%s,%f,%d\n"
+          (Loc.dual_string !Infer.root expr.pexp_loc)
+          time tp in
+      output_string file line;
+      close_out file
+
+  let typed' env structure expr =
+    (* 型推論と所要時間の計測 *)
+    let time0 = Sys.time () in
+    let tp =
+      try
+
+        let _ = Typemod.type_structure env structure in
+        true
+      with _ -> false in
+    let time1 = Sys.time () in
+
+    if print_slice then
+      Infer.write structure expr tp
+    else
+      begin
+        Infer.read expr.pexp_loc;
+        typed'' expr (if tp then 1 else 0) (time1 -. time0);
+      end;
+    (* 戻り値は bool *)
+    tp
+
+  let typed env item_cxt expr_cxt expr =
+    try
+      let structure =
+        List.map (
+          fun item ->
+            if not (Desc.internal item.pstr_loc expr.pexp_loc) then
+              item
+            else
+              match item.pstr_desc with
+              | Pstr_eval (e, attrs) ->
+                  if Desc.internal
+                      e.pexp_loc expr.pexp_loc then
+                    {item with pstr_desc = Pstr_eval (Slice.Exp.clean e, attrs)}
+                  else
+                    item
+
+              | Pstr_value (flg, vs) ->
+                  {item with
+                   pstr_desc =
+                     Pstr_value (flg, List.map (
+                         fun vb ->
+                           if Desc.internal
+                               vb.pvb_expr.pexp_loc expr.pexp_loc then
+                             {vb with pvb_expr = Slice.Exp.clean vb.pvb_expr}
+                           else
+                             vb
+                       ) vs)}
+              | _ -> item
+        ) (item_cxt expr_cxt expr) in
+      (* 型推論 *)
+      typed' env structure expr
+    with _ ->
+      true (* 省略 *)
+
+  (* 終了処理: ファイルの出力 *)
+  let finally expr time =
+    Infer.read expr.pexp_loc;
+    if check_make_slice () then
+      typed'' expr (-1) time;
+    expr
+
+end
